%from Stepan Pchelkin and Serge Gale

function C = C(q,dq)
%returns the C matrix from the manipulator model. 

global m2;
global l1 l2;
global Cmx2 Cmy2;

C_11 = -dq(2) * m2 * l1 * (Cmx2 * sin(q(2)) + Cmy2 * cos(q(2)) + sin(q(2)) * l2);
C_12 = -m2 * l1 * (Cmx2 * sin(q(2)) + Cmy2 * cos(q(2)) + sin(q(2)) * l2) * (dq(1) + dq(2));
C_21 = dq(1) * m2 * l1 * (Cmx2 * sin(q(2)) + Cmy2 * cos(q(2)) + sin(q(2)) * l2);
C_22 = 0;

C = [C_11 C_12; C_21 C_22;];

end