%Uncomment/comment to plot/display different things


%--------------------------trajectory tracking----------------------------
for i=1:length(states(:,1))
    q = states(i,1:2)';
    q1(i) = q(1);
    q2(i) = q(2);
    xe(:,i) = ForwardKinematic(q);
end

%t = states(:,5)';

load DesiredTrajectory %gives q used further here, also T
load Time %gives th
%plots the actual end effector trajectory
figure(1)
plot(xe(1,:),xe(2,:),'linewidth',1.5);
grid on;
hold on;
title('Trajectory End Effector');
xlabel('x,[m]')
ylabel('y,[m]')

%plots the actual and desired joint trajecotries
figure(2)
subplot(1,2,1);
plot(th,q(:,1),'r','linewidth',1.5);
grid on;
xlabel('t,[s]')
ylabel('q_1,[s]')
title('Trajectory q_1');
hold on
plot(th,q1(1:length(th)),'linewidth',1);
legend('Deisred Trajectory q_1', 'Actual Trajectory q_1')

subplot(1,2,2);
plot(th,q(:,2),'r','linewidth',1.5);
grid on;
xlabel('t,[s]')
ylabel('q_2,[s]')
title('Trajectory q_2');
hold on
plot(th,q2(1:length(th)),'linewidth',1);
legend('Desired Trajectory q_2', 'Actual Trajectory q_2')


SSE_trackError = sum((abs(q1(1:length(T))' - q(:,1)).^2)*(T(2) - T(1))) + sum((abs(q2(1:length(T))' - q(:,2)).^2));%*(T(2) - T(1)))
disp(['SSE tracking error for the whole simulation is ' num2str(SSE_trackError) ]);


%plot desired trajectory for end effector and joints
for i = 1:length(q)
    qt = q(i,1:2)';
    qe(:,i) = ForwardKinematic(qt);
end

%figure;
%plot(qe(1,:), qe(2,:), 'linewidth', 1.5)
%title(['Desired Trajectory End Effector']);
%grid on;
%xlabel('x, [m]');
%ylabel('y, [m]');

%figure;
%subplot(1,2,1);
%plot(th,q(:,1),'r','linewidth',1.5);%2
%grid on;
%xlabel('t,[s]')
%ylabel('q_1,[s]')
%title('Desired Trajectory q_1');

%subplot(1,2,2);
%plot(th,q(:,2),'r','linewidth',1.5);%2
%grid on;
%xlabel('t,[s]')
%ylabel('q_2,[s]')
%title('Desired Trajectory q_2');

dq = states(:,3:4)';

%figure;
%plot(t, dq(1,:), t, dq(2,:));
%grid on;
%hold on;
%xlabel('time');
%ylabel('dq');
%legend('dq(1)', 'dq(2)');

%------------------------approximation errors---------------------------
%for M matrix estimation
len = length(DATA);
d1_M = DATA(1, len-300:len);
d2_M = DATA(2, len-300:len);
d3_M = DATA(3, len-300:len);
d4_M = DATA(4, len-300:len);
rms_M11 = Rmse(d1_M);
rms_M12 = Rmse(d2_M);
rms_M21 = Rmse(d3_M);
rms_M22 = Rmse(d4_M);

d1_Mw = DATA(1,:);
d2_Mw = DATA(2,:);
d3_Mw = DATA(3,:);
d4_Mw = DATA(4,:);
rms_M11_w = Rmse(d1_Mw);
rms_M12_w = Rmse(d2_Mw);
rms_M21_w = Rmse(d3_Mw);
rms_M22_w = Rmse(d4_Mw);

%figure();
%plot(DATA(1,:));
%title(['estimating error M11']);

%figure();
%plot(DATA(2,:));
%title(['estimating error M12']);

%figure();
%plot(DATA(3,:));
%title(['estimating error M21']);

%figure();
%plot(DATA(4,:));
%title(['estimating error M22']);

%for C matrix estimation
len_C = length(DATA_C);
d1_C = DATA_C(1, len-300:len);
d2_C = DATA_C(2, len-300:len);
d3_C = DATA_C(3, len-300:len);
rms_C11 = Rmse(d1_C);
rms_C12 = Rmse(d2_C);
rms_C21 = Rmse(d3_C);
d1_Cw = DATA_C(1,:);
d2_Cw = DATA_C(2,:);
d3_Cw = DATA_C(3,:);
rms_C11_w = Rmse(d1_Cw);
rms_C12_w = Rmse(d2_Cw);
rms_C21_w = Rmse(d3_Cw);


%figure();
%plot(DATA_C(1,:));
%title(['estimating error C11']);

%figure();
%plot(DATA_C(2,:));
%title(['estimating error C12']);

%figure();
%plot(DATA_C(3,:));
%title(['estimating error C21']);

%figure(6);
%plot(DATA_C(4,:));
%title(['estimating error C22']);

%G matrix estimation
len_G = length(DATA_G);
d1_G = DATA_G(1, len-300:len);
d2_G = DATA_G(2, len-300:len);
rms_G11 = Rmse(d1_G);
rms_G12 = Rmse(d2_G);
d1_Gw = DATA_G(1,:);
d2_Gw = DATA_G(2,:);
rms_G11_w = Rmse(d1_Gw);
rms_G12_w = Rmse(d1_Gw);

%figure();
%plot(DATA_G(1,:));
%title(['estimating error G11']);

%figure();
%plot(DATA_G(2,:));
%title(['estimating error G12']);

%displaying the approximation error for the last 300 iterations
disp(['approximation error for the last 300 iterations and the whole simulation:']);
disp(['M11 - 300: ' num2str(rms_M11) ' and whole: ' num2str(rms_M11_w)]);
disp(['M12 - 300: ' num2str(rms_M12) ' and whole: ' num2str(rms_M12_w)]);
disp(['M21 - 300: ' num2str(rms_M21) ' and whole: ' num2str(rms_M21_w)]);
disp(['M22 - 300: ' num2str(rms_M22) ' and whole: ' num2str(rms_M22_w)]);

disp(['C11 - 300: ' num2str(rms_C11) ' and whole: ' num2str(rms_C11_w)]);
disp(['C12 - 300: ' num2str(rms_C12) ' and whole: ' num2str(rms_C12_w)]);
disp(['C21 - 300: ' num2str(rms_C21) ' and whole: ' num2str(rms_C21_w)]);

disp(['G11 - 300: ' num2str(rms_G11) ' and whole: ' num2str(rms_G11_w)]);
disp(['G12 - 300: ' num2str(rms_G12) ' and whole: ' num2str(rms_G12_w)]);


disp(['final NN sizes are: ' ]);
disp(['M11 - ' num2str(length(RBFNN_M_11.mu)) ]);
disp(['M12 - ' num2str(length(RBFNN_M_12.mu)) ]);
disp(['M21 - ' num2str(length(RBFNN_M_21.mu)) ]);
disp(['M22 - ' num2str(length(RBFNN_M_22.mu)) ]);

disp(['C11 - ' num2str(length(RBFNN_C_11.mu)) ]);
disp(['C12 - ' num2str(length(RBFNN_C_12.mu)) ]);
disp(['C21 - ' num2str(length(RBFNN_C_21.mu)) ]);

disp(['G11 - ' num2str(length(RBFNN_G_11.mu)) ]);
disp(['G12 - ' num2str(length(RBFNN_G_12.mu)) ]);



%--------------------------number of units pruned and when---------------

for i = 1 : length(M_11_prun(1,:))
    if M_11_prun(3,i) ~= 0
        disp(['M11: ' num2str(M_11_prun(3,i)) ' units pruned by Weight Magnitude at iteration ' num2str(M_11_prun(1,i))]);% ' with threshold ' num2str(m11_2(i))]);
    end
    if M_11_prun(5,i) ~= 0
        disp(['M11: ' num2str(M_11_prun(5,i)) ' units pruned by Node Output at iteration ' num2str(M_11_prun(1,i))]);% ' with threshold ' num2str(m11_2(i))]);
    end
    
    if M_12_prun(3,i) ~= 0
        disp(['M12: ' num2str(M_12_prun(3,i)) ' units pruned by Weight Magnitude at iteration ' num2str(M_12_prun(1,i))]);% ' with threshold ' num2str(m12_2(i))]);
    end
    if M_12_prun(5,i) ~= 0
        disp(['M12: ' num2str(M_12_prun(5,i)) ' units pruned by Node Output at iteration ' num2str(M_12_prun(1,i))]);% ' with threshold ' num2str(m12_2(i))]);
    end
    
    if M_21_prun(3,i) ~= 0
        disp(['M21: ' num2str(M_21_prun(3,i)) ' units pruned by Weight Magnitude at iteration ' num2str(M_21_prun(1,i))]);% ' with threshold ' num2str(m21_2(i))]);
    end
    if M_21_prun(5,i) ~= 0
        disp(['M21: ' num2str(M_21_prun(3,i)) ' units pruned by Node Output at iteration ' num2str(M_21_prun(1,i))]);% ' with threshold ' num2str(m21_2(i))]);
    end
    
    if M_22_prun(3,i) ~= 0
        disp(['M22: ' num2str(M_22_prun(3,i)) ' units pruned by Weight Magnitude at iteration ' num2str(M_22_prun(1,i))]);% ' with threshold ' num2str(m22_2(i))]);
    end
    if M_22_prun(5,i) ~= 0
        disp(['M22: ' num2str(M_22_prun(3,i)) ' units pruned by Node Output at iteration ' num2str(M_22_prun(1,i))]);% ' with threshold ' num2str(m22_2(i))]);
    end    
end


%figure();
%plot(m11_1, m11_2, m11_1, m11_3);
%legend('pruning threshold, p_th', 'number of units_pruned');
%title(['M_11']);

%figure();
%plot(m12_1, m12_2, m12_1, m12_3);
%legend('pruning threshold, p_th', 'number of units_pruned');
%title(['M_12']);

%figure();
%plot(m21_1, m21_2, m21_1, m21_3);
%legend('pruning threshold, p_th', 'number of units_pruned');
%title(['M_21']);

%figure();
%plot(m22_1, m22_2, m22_1, m22_3);
%legend('pruning threshold, p_th', 'number of units_pruned');
%title(['M_22']);


for i = 1 : length(C_11_prun(1,:))
    if C_11_prun(3,i) ~= 0
        disp(['C11: ' num2str(C_11_prun(3,i)) ' units pruned by Weight Magnitude at iteration ' num2str(C_11_prun(1,i))]);% ' with threshold ' num2str(C_11_prun(2,i))]);
    end
    if C_11_prun(5,i) ~= 0
        disp(['C11: ' num2str(C_11_prun(5,i)) ' units pruned by Node Output at iteration ' num2str(C_11_prun(1,i))]);% ' with threshold ' num2str(C_11_prun(4,i))]);
    end
    
    if C_12_prun(3,i) ~= 0
        disp(['C12: ' num2str(C_12_prun(3,i)) ' units pruned by Weight Magnitude at iteration ' num2str(C_12_prun(1,i))]);% ' with threshold ' num2str(C_12_prun(2,i))]);
    end
    if C_12_prun(5,i) ~= 0
        disp(['C12: ' num2str(C_12_prun(5,i)) ' units pruned by Node Output at iteration ' num2str(C_12_prun(1,i))]);% ' with threshold ' num2str(C_12_prun(4,i))]);
    end   
    
    if C_21_prun(3,i) ~= 0
        disp(['C21: ' num2str(C_21_prun(3,i)) ' units pruned by Weight Magnitude at iteration ' num2str(C_21_prun(1,i))]);% ' with threshold ' num2str(C_21_prun(2,o))]);
    end
     if C_21_prun(5,i) ~= 0
        disp(['C21: ' num2str(C_21_prun(5,i)) ' units pruned by Node Output at iteration ' num2str(C_21_prun(1,i))]);% ' with threshold ' num2str(C_21_prun(4,i))]);
     end
    
end

%figure();
%plot(c11_1, c11_2, c11_1, c11_3);
%legend('pruning threshold, p_th', 'number of units_pruned');
%title(['C_11']);

%figure();
%plot(c12_1, c12_2, c12_1, c12_3);
%legend('pruning threshold, p_th', 'number of units_pruned');
%title(['C_12']);

%figure();
%plot(c21_1, c21_2, c21_1, c21_3);
%legend('pruning threshold, p_th', 'number of units_pruned');
%title(['C_21']);


for i = 1 : length(G_11_prun(1,:))
    if G_11_prun(3,i) ~= 0
        disp(['G11: ' num2str(G_11_prun(3,i)) ' units pruned by Weight Magnitude at iteration ' num2str(G_11_prun(1,i))]);% ' with threshold ' num2str(G_11_prun(2,i))]);
    end
    if G_11_prun(5,i) ~= 0
        disp(['G11: ' num2str(G_11_prun(5,i)) ' units pruned by Node Output at iteration ' num2str(G_11_prun(1,i))]);% ' with threshold ' num2str(G_11_prun(4,i))]);
    end
    
    if G_12_prun(3,i) ~= 0
        disp(['G12: ' num2str(G_12_prun(3,i)) ' units pruned by Weight Magnitude at iteration ' num2str(G_12_prun(1,i))]);% ' with threshold ' num2str(G_12_prun(2,i))]);
    end
    if G_12_prun(5,i) ~= 0
        disp(['G12: ' num2str(G_12_prun(5,i)) ' units pruned by Node Output at iteration ' num2str(G_12_prun(1,i))]);% ' with threshold ' num2str(G_12_prun(4,i))]);
    end    
end

%figure();
%plot(g11_1, g11_2, g11_1, g11_3);
%legend('pruning threshold, p_th', 'number of units_pruned');
%title(['G_11']);

%figure();
%plot(g12_1, g12_2, g12_1, g12_3);
%legend('pruning threshold, p_th', 'number of units_pruned');
%title(['G_12']);