%from Stepan Pchelkin and Serge Gale

function Out = DynamicsOfManipulator(u)
%Returns qdot and qddot for the manipulator. Choose here if friction and
%disturbance should be included or not.

tau = u(1:2);
q = u(3:4);
dq = u(5:6);
%-------------------------------------------------------------------------%
%-------------------------------------------------------------------------%

Mt = M(q);
Ct = C(q, dq);
Gt = G(q);

%Friction and disturbance
%Ft = [0.7*dq(1); 0.7*dq(2)];
%d = [2;2];
%-------------------------------------------------------------------------%
%-------------------------------------------------------------------------%
Deriv = dq;

DDots = (Mt) \ (tau - Ct * Deriv - Gt);% - Ft - d);

Out = [Deriv; DDots];

end