clc
close all
clear all


%-----------------initializing constants for manipulator model----------
global m2,m2=50;
global m1,m1=50;
global l2,l2=1;
global l1,l1=1;
global Cmx1,Cmx1=-0.5*l1;
global Cmx2,Cmx2=-0.5*l2;
global Cmy1,Cmy1=0;
global Cmy2,Cmy2=0;
global I2z,I2z = 10;
global I1z,I1z = m1*(3*0.05^2 + l1^2)/12 + m1*(l1/2-(-Cmx1))^2;


%----------------changeable pruning thresholds--------------------------
global outp_th, outp_th = 0.15;
global outp_th_C, outp_th_C = 0.15;
global outp_th_G, outp_th_G = 0.15;
global weight_th, weight_th = 0.0;


%------------------initializing RBF networks-----------------------------
global RBFNN_M_11, RBFNN_M_11 = MRL.RBFN(1, 1, -pi, pi, 0.75);
global RBFNN_M_12, RBFNN_M_12 = MRL.RBFN(1, 1, -pi, pi, 0.75);
global RBFNN_M_21, RBFNN_M_21 = MRL.RBFN(1, 1, -pi, pi, 0.75);
global RBFNN_M_22, RBFNN_M_22 = MRL.RBFN(1, 1, 0, 30, 0.75);

global RBFNN_C_11, RBFNN_C_11 = MRL.RBFN(2, 1, -pi, pi, 0.75, -pi, pi, 0.75);
global RBFNN_C_12, RBFNN_C_12 = MRL.RBFN(2, 1, -pi, pi, 0.75, -pi, pi, 0.75);
global RBFNN_C_21, RBFNN_C_21 = MRL.RBFN(2, 1, -pi, pi, 0.75, -pi, pi, 0.75);


global RBFNN_G_11, RBFNN_G_11 = MRL.RBFN(2, 1, -pi, pi, 0.75, -pi, pi, 0.75);
global RBFNN_G_12, RBFNN_G_12 = MRL.RBFN(2, 1, -pi, pi, 0.75, -pi, pi, 0.75);


%----------------displaying initially networks--------------------------
disp(['starting NN sizes are: ' ]);
disp(['M11 - ' num2str(length(RBFNN_M_11.mu)) ]);
disp(['M12 - ' num2str(length(RBFNN_M_12.mu)) ]);
disp(['M21 - ' num2str(length(RBFNN_M_21.mu)) ]);
disp(['M22 - ' num2str(length(RBFNN_M_22.mu)) ]);

disp(['C11 - ' num2str(length(RBFNN_C_11.mu)) ]);
disp(['C12 - ' num2str(length(RBFNN_C_12.mu)) ]);
disp(['C21 - ' num2str(length(RBFNN_C_21.mu)) ]);

disp(['G11 - ' num2str(length(RBFNN_G_11.mu)) ]);
disp(['G12 - ' num2str(length(RBFNN_G_12.mu)) ]);


%--------------initializing activation function ratio sum-----------------
global act_outp_M_11, act_outp_M_11 = zeros(length(RBFNN_M_11.mu),1);
global act_outp_M_12, act_outp_M_12 = zeros(length(RBFNN_M_12.mu),1);
global act_outp_M_21, act_outp_M_21 = act_outp_M_12; 
global act_outp_M_22, act_outp_M_22 = zeros(length(RBFNN_M_22.mu),1);

global act_outp_C_11, act_outp_C_11 = zeros(length(RBFNN_C_11.mu),1);
global act_outp_C_12, act_outp_C_12 = zeros(length(RBFNN_C_12.mu),1);
global act_outp_C_21, act_outp_C_21 = zeros(length(RBFNN_C_21.mu),1); 

global act_outp_G_11, act_outp_G_11 = zeros(length(RBFNN_G_11.mu),1);
global act_outp_G_12, act_outp_G_12 = zeros(length(RBFNN_G_12.mu),1);


%-------------stores the approximation errors for each network---------
global DATA, DATA = zeros(4,1);
global DATA_C, DATA_C = zeros(3,1);
global DATA_G, DATA_G = zeros(2,1);

%times there have been pruned units whit pruneW, used for growing threshold
global n_prunW_M, n_prunW_M = ones(4,1); 
global n_prunW_C, n_prunW_C = ones(3,1); 
global n_prunW_G, n_prunW_G = ones(2,1); 

%saves: pruning number, p_thW, units_prunedW , pthO, units_prunedO
global M_11_prun, M_11_prun = zeros(5,1);
global M_12_prun, M_12_prun = zeros(5,1);
global M_21_prun, M_21_prun = zeros(5,1);
global M_22_prun, M_22_prun = zeros(5,1);

global C_11_prun, C_11_prun = zeros(5,1);
global C_12_prun, C_12_prun = zeros(5,1);
global C_21_prun, C_21_prun = zeros(5,1);

global G_11_prun, G_11_prun = zeros(5,1);
global G_12_prun, G_12_prun = zeros(5,1);

%saturation in simulink
global umax umin;
umax = [1;1]*5000;
umin = [-1;-1]*5000;

%gains used in the inverse kinematic controller
global Kp Kd

Kp = diag([250,450]);
Kd = diag([0.5,4]);


e = 0;
load DesiredTrajectory
% Initial position of manipulator arm x0 = [q1; q2; dq1; dq2]
x0 = [pi/3 + e;-(pi-pi/3) + e; dq(1,1);dq(1,2)];

