%from Stepan Pchelkin and Serge Gale

function M = M(q)
%returns the M matrix from the manipulator model

global m1 m2;
global l1 l2;
global Cmx1 Cmx2;
global Cmy1 Cmy2;
global I1z I2z;

M_11 = (m2 * l2 ^ 2) + I1z + I2z + (m2 * l1 ^ 2) + (2 * m1 * Cmx1 * l1) + (m2 * Cmx2 ^ 2) + m2 * Cmy2 ^ 2 + (2 * m2 * Cmx2 * l2) + 0.2e1 * m2 * l1 * Cmx2 * cos(q(2)) - 0.2e1 * m2 * l1 * Cmy2 * sin(q(2)) + 0.2e1 * m2 * l1 * cos(q(2)) * l2 + (m1 * Cmy1 ^ 2) + (m1 * l1 ^ 2) + (m1 * Cmx1 ^ 2);
M_12 = (m2 * l2 ^ 2) + I2z + (m2 * Cmx2 ^ 2) + m2 * Cmy2 ^ 2 + (2 * m2 * Cmx2 * l2) + m2 * l1 * Cmx2 * cos(q(2)) - m2 * l1 * Cmy2 * sin(q(2)) + m2 * l1 * cos(q(2)) * l2;
M_21 = M_12;
M_22 = (m2 * l2 ^ 2) + I2z + (m2 * Cmx2 ^ 2) + m2 * Cmy2 ^ 2 + (2 * m2 * Cmx2 * l2);

M = [M_11 M_12; M_21 M_22];

end
