%framework from Serge Gale

function Out = Tau(u)
%finds the control torque from the inverse kinematic controller. Choose
%between using the manipulator model and RBF networks

global Kp;
global Kd;

%----------------------------desired trajectory---------------------------%
qd = u(1:2);
dqd = u(3:4);
ddqd = u(5:6);
%-------------------------------------------------------------------------%
q = u(7:8);
dq = u(9:10);
%-------------------------------------------------------------------------%


%Estimations by RBF networks
Mt = M_hat(q);
Ct = C_hat(q,dq);
Gt = G_hat(q);

%Model of manipulator
%Mt = M(q);
%Ct = C(q,dq);
%Gt = G(q);

aq = ddqd + (Kd*(dqd - dq) + Kp*(qd - q));
Out = Mt*aq + Ct*dq + Gt;


end