function C = C_hat(q,dq)
%Finds the estimation of C(q,dq) by using RBFNN with pruning

global  m2 m3; 
global lmx2 lmy2 lmz2;
global lmx3 lmy3 lmz3;
global I2x I2y;
global I3x I3z;

%RBF networks
global RBFNN_C_11 RBFNN_C_12 RBFNN_C_13 RBFNN_C_21 RBFNN_C_22 RBFNN_C_23 RBFNN_C_31 RBFNN_C_32;
%stores the network's estimation errors, weights norm
global DATA_C norm_C;
%activation function output ratio sums
global act_outp_C_11 act_outp_C_12 act_outp_C_13 act_outp_C_21 act_outp_C_22 act_outp_C_23 act_outp_C_31 act_outp_C_32;
%pruning thresholds 
global weight_th_C outp_th_C;
%counter for number of times network pruned by weight pruning
global n_prunW_C; 
%stores iteration number, p_thW, prunedW, p_thO, prunedO
global C_11_prun C_12_prun C_13_prun C_21_prun C_22_prun C_23_prun C_31_prun C_32_prun;

C_11 = -0.1e1 * dq(2) * m3 * lmx3 * lmz3 - 0.7000000000e-1 * dq(3) * m3 * lmz3 * sin(q(2)) * cos(q(3)) - 0.7000000000e-1 * dq(3) * m3 * lmz3 * cos(q(2)) * sin(q(3)) - 0.3960500000e0 * dq(3) * m3 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) + 0.2e1 * dq(3) * I3z * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.1602000000e0 * dq(3) * m3 * cos(q(2)) * sin(q(3)) * sin(q(2)) - 0.3960500000e0 * dq(3) * m3 * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.2e1 * dq(3) * I3x * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) + 0.2e1 * dq(3) * I3z * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.3600000000e0 * dq(3) * m3 * cos(q(2)) ^ 2 * lmx3 * sin(q(3)) + 0.3600000000e0 * dq(3) * m3 * cos(q(2)) ^ 2 * lmz3 * cos(q(3)) - 0.1780000000e1 * dq(3) * m3 * lmx3 * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 + 0.2e1 * dq(3) * m3 * lmx3 * cos(q(3)) ^ 2 * lmz3 + dq(3) * m3 * lmz3 ^ 2 * cos(q(3)) * sin(q(3)) + 0.8900000000e0 * dq(3) * m3 * lmz3 * cos(q(3)) * sin(q(3)) - 0.1e1 * dq(3) * m3 * lmx3 ^ 2 * cos(q(3)) * sin(q(3)) - 0.4450000000e0 * dq(2) * m3 * lmx3 - 0.1e1 * dq(3) * m3 * lmx3 ^ 2 * cos(q(2)) * sin(q(2)) + dq(3) * m3 * lmz3 ^ 2 * cos(q(2)) * sin(q(2)) + 0.8900000000e0 * dq(3) * m3 * lmz3 * cos(q(2)) * sin(q(2)) - 0.2e1 * dq(2) * m3 * lmz3 ^ 2 * cos(q(2)) ^ 2 * cos(q(3)) * sin(q(3)) - 0.1780000000e1 * dq(2) * m3 * lmz3 * cos(q(2)) ^ 2 * cos(q(3)) * sin(q(3)) + 0.2e1 * dq(2) * m3 * lmx3 ^ 2 * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.4e1 * dq(2) * m3 * lmx3 * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 * lmz3 + 0.2e1 * dq(2) * m3 * lmx3 ^ 2 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.2e1 * dq(2) * m3 * lmz3 ^ 2 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.1780000000e1 * dq(2) * m3 * lmz3 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.7200000000e0 * dq(2) * m3 * lmx3 * cos(q(2)) * cos(q(3)) * sin(q(2)) - 0.7200000000e0 * dq(2) * m3 * lmz3 * cos(q(2)) * sin(q(3)) * sin(q(2)) - 0.2e1 * dq(3) * m3 * lmz3 ^ 2 * cos(q(2)) ^ 2 * cos(q(3)) * sin(q(3)) - 0.1780000000e1 * dq(3) * m3 * lmz3 * cos(q(2)) ^ 2 * cos(q(3)) * sin(q(3)) + 0.2e1 * dq(3) * m3 * lmx3 ^ 2 * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.4e1 * dq(3) * m3 * lmx3 * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 * lmz3 + 0.2e1 * dq(3) * m3 * lmx3 ^ 2 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.2e1 * dq(3) * m3 * lmz3 ^ 2 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.1780000000e1 * dq(3) * m3 * lmz3 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.3600000000e0 * dq(3) * m3 * lmx3 * cos(q(2)) * cos(q(3)) * sin(q(2)) - 0.3600000000e0 * dq(3) * m3 * lmz3 * cos(q(2)) * sin(q(3)) * sin(q(2)) - 0.3600000000e0 * dq(3) * m3 * lmz3 * cos(q(3)) + 0.3600000000e0 * dq(3) * m3 * lmx3 * sin(q(3)) + 0.3204000000e0 * dq(2) * m3 * cos(q(2)) ^ 2 * cos(q(3)) - 0.3115000000e-1 * dq(2) * m3 * cos(q(2)) * sin(q(3)) - 0.3115000000e-1 * dq(2) * m3 * sin(q(2)) * cos(q(3)) + 0.8900000000e0 * dq(2) * m3 * lmx3 * cos(q(2)) ^ 2 + 0.7200000000e0 * dq(2) * m2 * cos(q(2)) ^ 2 * lmy2 + dq(2) * I3x * cos(q(2)) * sin(q(2)) + 0.7000000000e-1 * dq(2) * m2 * cos(q(2)) * lmx2 - 0.7000000000e-1 * dq(2) * m2 * sin(q(2)) * lmy2 + 0.3276250000e0 * dq(2) * m3 * cos(q(2)) * sin(q(2)) - 0.1e1 * dq(2) * cos(q(2)) * I2x * sin(q(2)) - 0.1e1 * dq(2) * I3z * cos(q(2)) * sin(q(2)) + 0.1296000000e0 * dq(2) * m2 * cos(q(2)) * sin(q(2)) + dq(2) * I2y * cos(q(2)) * sin(q(2)) + 0.1602000000e0 * dq(3) * m3 * cos(q(2)) ^ 2 * cos(q(3)) - 0.3115000000e-1 * dq(3) * m3 * cos(q(2)) * sin(q(3)) - 0.3115000000e-1 * dq(3) * m3 * sin(q(2)) * cos(q(3)) + dq(3) * I3x * cos(q(3)) * sin(q(3)) - 0.1e1 * dq(3) * I3z * cos(q(3)) * sin(q(3)) + 0.1980250000e0 * dq(3) * m3 * cos(q(3)) * sin(q(3)) + 0.8900000000e0 * dq(3) * m3 * lmx3 * cos(q(3)) ^ 2 + 0.4e1 * dq(2) * m3 * lmx3 * cos(q(2)) * cos(q(3)) * lmz3 * sin(q(3)) * sin(q(2)) + 0.4e1 * dq(3) * m3 * lmx3 * cos(q(2)) * cos(q(3)) * lmz3 * sin(q(3)) * sin(q(2)) + 0.1780000000e1 * dq(2) * m3 * lmx3 * cos(q(2)) * cos(q(3)) * sin(q(3)) * sin(q(2)) + 0.1780000000e1 * dq(3) * m3 * lmx3 * cos(q(2)) * cos(q(3)) * sin(q(3)) * sin(q(2)) - 0.1e1 * dq(3) * m3 * lmx3 * lmz3 + 0.2520000000e-1 * dq(2) * m2 * cos(q(2)) + 0.2520000000e-1 * dq(2) * m3 * cos(q(2)) - 0.1602000000e0 * dq(3) * m3 * cos(q(3)) + 0.2e1 * dq(2) * m3 * lmx3 * cos(q(3)) ^ 2 * lmz3 + 0.2e1 * dq(3) * m3 * lmx3 * cos(q(2)) ^ 2 * lmz3 + 0.8900000000e0 * dq(2) * m3 * lmx3 * cos(q(3)) ^ 2 + dq(2) * I3x * sin(q(3)) * cos(q(3)) - 0.1e1 * dq(2) * I3z * sin(q(3)) * cos(q(3)) + 0.3600000000e0 * dq(2) * m3 * lmx3 * sin(q(3)) - 0.3600000000e0 * dq(2) * m3 * lmz3 * cos(q(3)) + dq(2) * m3 * lmz3 ^ 2 * cos(q(3)) * sin(q(3)) + 0.8900000000e0 * dq(2) * m3 * lmz3 * cos(q(3)) * sin(q(3)) - 0.1e1 * dq(2) * m3 * lmx3 ^ 2 * sin(q(3)) * cos(q(3)) - 0.1602000000e0 * dq(2) * m3 * cos(q(3)) + 0.8900000000e0 * dq(3) * m3 * lmx3 * cos(q(2)) ^ 2 + 0.1980250000e0 * dq(3) * m3 * cos(q(2)) * sin(q(2)) - 0.1e1 * dq(3) * I3z * cos(q(2)) * sin(q(2)) + dq(3) * I3x * cos(q(2)) * sin(q(2)) - 0.4450000000e0 * dq(3) * m3 * lmx3 + 0.2e1 * dq(2) * m3 * lmx3 * cos(q(2)) ^ 2 * lmz3 + 0.2e1 * dq(2) * m2 * cos(q(2)) ^ 2 * lmx2 * lmy2 - 0.2e1 * dq(2) * I3x * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) + 0.7000000000e-1 * dq(2) * m3 * lmx3 * sin(q(2)) * sin(q(3)) - 0.7000000000e-1 * dq(2) * m3 * lmx3 * cos(q(2)) * cos(q(3)) - 0.7000000000e-1 * dq(2) * m3 * lmz3 * sin(q(2)) * cos(q(3)) - 0.7000000000e-1 * dq(2) * m3 * lmz3 * cos(q(2)) * sin(q(3)) - 0.3960500000e0 * dq(2) * m3 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) + 0.2e1 * dq(2) * I3z * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.3204000000e0 * dq(2) * m3 * cos(q(2)) * sin(q(3)) * sin(q(2)) - 0.3960500000e0 * dq(2) * m3 * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.2e1 * dq(2) * I3x * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) + 0.2e1 * dq(2) * I3z * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.7200000000e0 * dq(2) * m3 * cos(q(2)) ^ 2 * lmx3 * sin(q(3)) + 0.7200000000e0 * dq(2) * m3 * cos(q(2)) ^ 2 * lmz3 * cos(q(3)) - 0.1780000000e1 * dq(2) * m3 * lmx3 * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 - 0.1e1 * dq(2) * m2 * lmy2 ^ 2 * cos(q(2)) * sin(q(2)) + dq(2) * m2 * cos(q(2)) * lmx2 ^ 2 * sin(q(2)) + 0.7200000000e0 * dq(2) * m2 * cos(q(2)) * lmx2 * sin(q(2)) + dq(2) * m3 * lmz3 ^ 2 * cos(q(2)) * sin(q(2)) + 0.8900000000e0 * dq(2) * m3 * lmz3 * cos(q(2)) * sin(q(2)) - 0.1e1 * dq(2) * m3 * lmx3 ^ 2 * cos(q(2)) * sin(q(2)) - 0.2e1 * dq(3) * I3x * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) + 0.7000000000e-1 * dq(3) * m3 * lmx3 * sin(q(2)) * sin(q(3)) - 0.7000000000e-1 * dq(3) * m3 * lmx3 * cos(q(2)) * cos(q(3)) - 0.3600000000e0 * dq(2) * m2 * lmy2 + 0.1980250000e0 * dq(2) * m3 * sin(q(3)) * cos(q(3)) - 0.1e1 * dq(2) * m2 * lmx2 * lmy2;
C_12 = -0.1602000000e0 * dq(1) * m3 * cos(q(3)) - 0.2e1 * dq(1) * m3 * lmz3 ^ 2 * cos(q(2)) ^ 2 * cos(q(3)) * sin(q(3)) - 0.1780000000e1 * dq(1) * m3 * lmz3 * cos(q(2)) ^ 2 * cos(q(3)) * sin(q(3)) + 0.2e1 * dq(1) * m3 * lmx3 ^ 2 * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.4e1 * dq(1) * m3 * lmx3 * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 * lmz3 + 0.2e1 * dq(1) * m3 * lmx3 ^ 2 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.2e1 * dq(1) * m3 * lmz3 ^ 2 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.1780000000e1 * dq(1) * m3 * lmz3 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.7200000000e0 * dq(1) * m3 * lmx3 * cos(q(2)) * cos(q(3)) * sin(q(2)) - 0.7200000000e0 * dq(1) * m3 * lmz3 * cos(q(2)) * sin(q(3)) * sin(q(2)) - 0.1e1 * dq(2) * m3 * lmy3 * lmx3 * sin(q(2)) * cos(q(3)) - 0.1e1 * dq(2) * m3 * lmy3 * lmx3 * cos(q(2)) * sin(q(3)) - 0.1e1 * dq(2) * m3 * lmy3 * lmz3 * sin(q(2)) * sin(q(3)) + dq(2) * m3 * lmy3 * lmz3 * cos(q(2)) * cos(q(3)) - 0.1e1 * m3 * lmy3 * dq(3) * lmx3 * sin(q(2)) * cos(q(3)) - 0.1e1 * m3 * lmy3 * dq(3) * lmx3 * cos(q(2)) * sin(q(3)) - 0.1e1 * m3 * lmy3 * dq(3) * lmz3 * sin(q(2)) * sin(q(3)) + m3 * lmy3 * dq(3) * lmz3 * cos(q(2)) * cos(q(3)) - 0.3960500000e0 * dq(1) * m3 * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.2e1 * dq(1) * I3x * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) + 0.2e1 * dq(1) * I3z * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.7200000000e0 * dq(1) * m3 * cos(q(2)) ^ 2 * lmx3 * sin(q(3)) + 0.7200000000e0 * dq(1) * m3 * cos(q(2)) ^ 2 * lmz3 * cos(q(3)) - 0.1780000000e1 * dq(1) * m3 * lmx3 * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 + 0.2e1 * dq(1) * m3 * lmx3 * cos(q(3)) ^ 2 * lmz3 + dq(1) * m3 * lmz3 ^ 2 * cos(q(3)) * sin(q(3)) + 0.8900000000e0 * dq(1) * m3 * lmz3 * cos(q(3)) * sin(q(3)) - 0.1e1 * dq(1) * m3 * lmx3 ^ 2 * cos(q(3)) * sin(q(3)) - 0.4450000000e0 * dq(2) * m3 * lmy3 * sin(q(2)) * sin(q(3)) + 0.4450000000e0 * dq(2) * m3 * lmy3 * cos(q(2)) * cos(q(3)) - 0.4450000000e0 * m3 * lmy3 * dq(3) * sin(q(2)) * sin(q(3)) + 0.4450000000e0 * m3 * lmy3 * dq(3) * cos(q(2)) * cos(q(3)) - 0.2e1 * dq(1) * I3x * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) + 0.7000000000e-1 * dq(1) * m3 * lmx3 * sin(q(2)) * sin(q(3)) - 0.7000000000e-1 * dq(1) * m3 * lmx3 * cos(q(2)) * cos(q(3)) - 0.7000000000e-1 * dq(1) * m3 * lmz3 * sin(q(2)) * cos(q(3)) - 0.7000000000e-1 * dq(1) * m3 * lmz3 * cos(q(2)) * sin(q(3)) - 0.3960500000e0 * dq(1) * m3 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) + 0.2e1 * dq(1) * I3z * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.3204000000e0 * dq(1) * m3 * cos(q(2)) * sin(q(3)) * sin(q(2)) + 0.4e1 * dq(1) * m3 * lmx3 * cos(q(2)) * cos(q(3)) * lmz3 * sin(q(3)) * sin(q(2)) + 0.7200000000e0 * dq(1) * m2 * cos(q(2)) ^ 2 * lmy2 + 0.7000000000e-1 * dq(1) * m2 * cos(q(2)) * lmx2 - 0.7000000000e-1 * dq(1) * m2 * sin(q(2)) * lmy2 - 0.1e1 * dq(1) * cos(q(2)) * I2x * sin(q(2)) + 0.1296000000e0 * dq(1) * m2 * cos(q(2)) * sin(q(2)) + dq(1) * I2y * cos(q(2)) * sin(q(2)) + 0.3600000000e0 * dq(2) * m2 * lmz2 * sin(q(2)) + 0.3600000000e0 * dq(2) * m3 * lmy3 * sin(q(2)) + 0.2e1 * dq(1) * m3 * lmx3 * cos(q(2)) ^ 2 * lmz3 + 0.3204000000e0 * dq(1) * m3 * cos(q(2)) ^ 2 * cos(q(3)) - 0.3115000000e-1 * dq(1) * m3 * cos(q(2)) * sin(q(3)) - 0.3115000000e-1 * dq(1) * m3 * sin(q(2)) * cos(q(3)) + dq(1) * I3x * cos(q(3)) * sin(q(3)) - 0.1e1 * dq(1) * I3z * cos(q(3)) * sin(q(3)) + 0.1980250000e0 * dq(1) * m3 * cos(q(3)) * sin(q(3)) + 0.8900000000e0 * dq(1) * m3 * lmx3 * cos(q(3)) ^ 2 - 0.3600000000e0 * dq(1) * m3 * lmz3 * cos(q(3)) + 0.3600000000e0 * dq(1) * m3 * lmx3 * sin(q(3)) - 0.3600000000e0 * dq(1) * m2 * lmy2 + dq(1) * m3 * lmz3 ^ 2 * cos(q(2)) * sin(q(2)) + 0.8900000000e0 * dq(1) * m3 * lmz3 * cos(q(2)) * sin(q(2)) - 0.1e1 * dq(1) * m2 * lmx2 * lmy2 + 0.2520000000e-1 * dq(1) * m2 * cos(q(2)) + 0.2520000000e-1 * dq(1) * m3 * cos(q(2)) - 0.1e1 * dq(1) * m3 * lmx3 * lmz3 + 0.2e1 * dq(1) * m2 * cos(q(2)) ^ 2 * lmx2 * lmy2 - 0.1e1 * dq(1) * m2 * lmy2 ^ 2 * cos(q(2)) * sin(q(2)) + dq(1) * m2 * cos(q(2)) * lmx2 ^ 2 * sin(q(2)) + 0.7200000000e0 * dq(1) * m2 * cos(q(2)) * lmx2 * sin(q(2)) + dq(2) * m2 * lmz2 * cos(q(2)) * lmy2 + dq(2) * m2 * lmz2 * sin(q(2)) * lmx2 + 0.1780000000e1 * dq(1) * m3 * lmx3 * cos(q(2)) * cos(q(3)) * sin(q(3)) * sin(q(2)) - 0.1e1 * dq(1) * m3 * lmx3 ^ 2 * cos(q(2)) * sin(q(2)) - 0.4450000000e0 * dq(1) * m3 * lmx3 + 0.3276250000e0 * dq(1) * m3 * cos(q(2)) * sin(q(2)) + dq(1) * I3x * cos(q(2)) * sin(q(2)) - 0.1e1 * dq(1) * I3z * cos(q(2)) * sin(q(2)) + 0.8900000000e0 * dq(1) * m3 * lmx3 * cos(q(2)) ^ 2;
C_13 = -0.1602000000e0 * dq(1) * m3 * cos(q(3)) - 0.2e1 * dq(1) * m3 * lmz3 ^ 2 * cos(q(2)) ^ 2 * cos(q(3)) * sin(q(3)) - 0.1780000000e1 * dq(1) * m3 * lmz3 * cos(q(2)) ^ 2 * cos(q(3)) * sin(q(3)) + 0.2e1 * dq(1) * m3 * lmx3 ^ 2 * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.4e1 * dq(1) * m3 * lmx3 * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 * lmz3 + 0.2e1 * dq(1) * m3 * lmx3 ^ 2 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.2e1 * dq(1) * m3 * lmz3 ^ 2 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.1780000000e1 * dq(1) * m3 * lmz3 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.3600000000e0 * dq(1) * m3 * lmx3 * cos(q(2)) * cos(q(3)) * sin(q(2)) - 0.3600000000e0 * dq(1) * m3 * lmz3 * cos(q(2)) * sin(q(3)) * sin(q(2)) - 0.1e1 * dq(2) * m3 * lmy3 * lmx3 * sin(q(2)) * cos(q(3)) - 0.1e1 * dq(2) * m3 * lmy3 * lmx3 * cos(q(2)) * sin(q(3)) - 0.1e1 * dq(2) * m3 * lmy3 * lmz3 * sin(q(2)) * sin(q(3)) + dq(2) * m3 * lmy3 * lmz3 * cos(q(2)) * cos(q(3)) - 0.1e1 * m3 * lmy3 * dq(3) * lmx3 * sin(q(2)) * cos(q(3)) - 0.1e1 * m3 * lmy3 * dq(3) * lmx3 * cos(q(2)) * sin(q(3)) - 0.1e1 * m3 * lmy3 * dq(3) * lmz3 * sin(q(2)) * sin(q(3)) + m3 * lmy3 * dq(3) * lmz3 * cos(q(2)) * cos(q(3)) - 0.3960500000e0 * dq(1) * m3 * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.2e1 * dq(1) * I3x * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) + 0.2e1 * dq(1) * I3z * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.3600000000e0 * dq(1) * m3 * cos(q(2)) ^ 2 * lmx3 * sin(q(3)) + 0.3600000000e0 * dq(1) * m3 * cos(q(2)) ^ 2 * lmz3 * cos(q(3)) - 0.1780000000e1 * dq(1) * m3 * lmx3 * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 + 0.2e1 * dq(1) * m3 * lmx3 * cos(q(3)) ^ 2 * lmz3 + dq(1) * m3 * lmz3 ^ 2 * cos(q(3)) * sin(q(3)) + 0.8900000000e0 * dq(1) * m3 * lmz3 * cos(q(3)) * sin(q(3)) - 0.1e1 * dq(1) * m3 * lmx3 ^ 2 * cos(q(3)) * sin(q(3)) - 0.4450000000e0 * dq(2) * m3 * lmy3 * sin(q(2)) * sin(q(3)) + 0.4450000000e0 * dq(2) * m3 * lmy3 * cos(q(2)) * cos(q(3)) - 0.4450000000e0 * m3 * lmy3 * dq(3) * sin(q(2)) * sin(q(3)) + 0.4450000000e0 * m3 * lmy3 * dq(3) * cos(q(2)) * cos(q(3)) - 0.2e1 * dq(1) * I3x * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) + 0.7000000000e-1 * dq(1) * m3 * lmx3 * sin(q(2)) * sin(q(3)) - 0.7000000000e-1 * dq(1) * m3 * lmx3 * cos(q(2)) * cos(q(3)) - 0.7000000000e-1 * dq(1) * m3 * lmz3 * sin(q(2)) * cos(q(3)) - 0.7000000000e-1 * dq(1) * m3 * lmz3 * cos(q(2)) * sin(q(3)) - 0.3960500000e0 * dq(1) * m3 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) + 0.2e1 * dq(1) * I3z * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.1602000000e0 * dq(1) * m3 * cos(q(2)) * sin(q(3)) * sin(q(2)) + 0.4e1 * dq(1) * m3 * lmx3 * cos(q(2)) * cos(q(3)) * lmz3 * sin(q(3)) * sin(q(2)) + 0.2e1 * dq(1) * m3 * lmx3 * cos(q(2)) ^ 2 * lmz3 + 0.1602000000e0 * dq(1) * m3 * cos(q(2)) ^ 2 * cos(q(3)) - 0.3115000000e-1 * dq(1) * m3 * cos(q(2)) * sin(q(3)) - 0.3115000000e-1 * dq(1) * m3 * sin(q(2)) * cos(q(3)) + dq(1) * I3x * cos(q(3)) * sin(q(3)) - 0.1e1 * dq(1) * I3z * cos(q(3)) * sin(q(3)) + 0.1980250000e0 * dq(1) * m3 * cos(q(3)) * sin(q(3)) + 0.8900000000e0 * dq(1) * m3 * lmx3 * cos(q(3)) ^ 2 - 0.3600000000e0 * dq(1) * m3 * lmz3 * cos(q(3)) + 0.3600000000e0 * dq(1) * m3 * lmx3 * sin(q(3)) + dq(1) * m3 * lmz3 ^ 2 * cos(q(2)) * sin(q(2)) + 0.8900000000e0 * dq(1) * m3 * lmz3 * cos(q(2)) * sin(q(2)) - 0.1e1 * dq(1) * m3 * lmx3 * lmz3 + 0.1780000000e1 * dq(1) * m3 * lmx3 * cos(q(2)) * cos(q(3)) * sin(q(3)) * sin(q(2)) - 0.1e1 * dq(1) * m3 * lmx3 ^ 2 * cos(q(2)) * sin(q(2)) - 0.4450000000e0 * dq(1) * m3 * lmx3 + 0.1980250000e0 * dq(1) * m3 * cos(q(2)) * sin(q(2)) + dq(1) * I3x * cos(q(2)) * sin(q(2)) - 0.1e1 * dq(1) * I3z * cos(q(2)) * sin(q(2)) + 0.8900000000e0 * dq(1) * m3 * lmx3 * cos(q(2)) ^ 2;
C_21 = 0.2500000000e-4 * dq(1) * (0.17800e5 * m3 * lmx3 + 0.40000e5 * m2 * lmx2 * lmy2 + 0.14400e5 * m2 * lmy2 - 0.35600e5 * m3 * lmx3 * cos(q(2)) ^ 2 + 0.80000e5 * I3x * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.28800e5 * m2 * cos(q(2)) ^ 2 * lmy2 - 0.2800e4 * m3 * lmx3 * sin(q(2)) * sin(q(3)) + 0.2800e4 * m3 * lmx3 * cos(q(2)) * cos(q(3)) + 0.2800e4 * m3 * lmz3 * sin(q(2)) * cos(q(3)) + 0.2800e4 * m3 * lmz3 * cos(q(2)) * sin(q(3)) - 0.12816e5 * m3 * cos(q(2)) ^ 2 * cos(q(3)) + 0.15842e5 * m3 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) + 0.40000e5 * m2 * lmy2 ^ 2 * cos(q(2)) * sin(q(2)) - 0.40000e5 * m2 * cos(q(2)) * lmx2 ^ 2 * sin(q(2)) - 0.28800e5 * m2 * cos(q(2)) * lmx2 * sin(q(2)) - 0.80000e5 * I3z * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.40000e5 * m3 * lmz3 ^ 2 * cos(q(2)) * sin(q(2)) - 0.35600e5 * m3 * lmz3 * cos(q(2)) * sin(q(2)) + 0.40000e5 * m3 * lmx3 ^ 2 * cos(q(2)) * sin(q(2)) + 0.12816e5 * m3 * cos(q(2)) * sin(q(3)) * sin(q(2)) + 0.80000e5 * m3 * lmz3 ^ 2 * cos(q(2)) ^ 2 * cos(q(3)) * sin(q(3)) + 0.71200e5 * m3 * lmz3 * cos(q(2)) ^ 2 * cos(q(3)) * sin(q(3)) - 0.80000e5 * m3 * lmx3 ^ 2 * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) + 0.160000e6 * m3 * lmx3 * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 * lmz3 - 0.71200e5 * m3 * lmx3 * cos(q(2)) * cos(q(3)) * sin(q(3)) * sin(q(2)) - 0.40000e5 * I3x * cos(q(2)) * sin(q(2)) - 0.2800e4 * m2 * cos(q(2)) * lmx2 + 0.1246e4 * m3 * cos(q(2)) * sin(q(3)) + 0.2800e4 * m2 * sin(q(2)) * lmy2 + 0.1246e4 * m3 * sin(q(2)) * cos(q(3)) - 0.13105e5 * m3 * cos(q(2)) * sin(q(2)) + 0.40000e5 * cos(q(2)) * I2x * sin(q(2)) + 0.40000e5 * I3z * cos(q(2)) * sin(q(2)) - 0.40000e5 * I3x * cos(q(3)) * sin(q(3)) + 0.40000e5 * I3z * cos(q(3)) * sin(q(3)) - 0.7921e4 * m3 * cos(q(3)) * sin(q(3)) - 0.14400e5 * m3 * lmx3 * sin(q(3)) + 0.14400e5 * m3 * lmz3 * cos(q(3)) + 0.15842e5 * m3 * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.80000e5 * m3 * lmx3 * cos(q(2)) ^ 2 * lmz3 + 0.80000e5 * I3x * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.80000e5 * I3z * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.80000e5 * m2 * cos(q(2)) ^ 2 * lmx2 * lmy2 + 0.28800e5 * m3 * cos(q(2)) ^ 2 * lmx3 * sin(q(3)) - 0.28800e5 * m3 * cos(q(2)) ^ 2 * lmz3 * cos(q(3)) - 0.80000e5 * m3 * lmx3 ^ 2 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) + 0.80000e5 * m3 * lmz3 ^ 2 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) + 0.71200e5 * m3 * lmz3 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) + 0.28800e5 * m3 * lmx3 * cos(q(2)) * cos(q(3)) * sin(q(2)) + 0.28800e5 * m3 * lmz3 * cos(q(2)) * sin(q(3)) * sin(q(2)) + 0.71200e5 * m3 * lmx3 * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 - 0.80000e5 * m3 * lmx3 * cos(q(3)) ^ 2 * lmz3 - 0.160000e6 * m3 * lmx3 * cos(q(2)) * cos(q(3)) * lmz3 * sin(q(3)) * sin(q(2)) - 0.1008e4 * m2 * cos(q(2)) - 0.1008e4 * m3 * cos(q(2)) + 0.6408e4 * m3 * cos(q(3)) - 0.40000e5 * m3 * lmz3 ^ 2 * cos(q(3)) * sin(q(3)) - 0.35600e5 * m3 * lmz3 * cos(q(3)) * sin(q(3)) + 0.40000e5 * m3 * lmx3 ^ 2 * cos(q(3)) * sin(q(3)) - 0.35600e5 * m3 * lmx3 * cos(q(3)) ^ 2 - 0.5184e4 * m2 * cos(q(2)) * sin(q(2)) - 0.40000e5 * I2y * cos(q(2)) * sin(q(2)) + 0.40000e5 * m3 * lmx3 * lmz3);
C_22 = -0.1800000000e-2 * dq(3) * m3 * (0.89e2 * cos(q(3)) - 0.200e3 * lmx3 * sin(q(3)) + 0.200e3 * lmz3 * cos(q(3)));
C_23 = -0.1800000000e-2 * m3 * (0.89e2 * dq(2) * cos(q(3)) - 0.200e3 * dq(2) * lmx3 * sin(q(3)) + 0.200e3 * dq(2) * lmz3 * cos(q(3)) + 0.89e2 * dq(3) * cos(q(3)) - 0.200e3 * dq(3) * lmx3 * sin(q(3)) + 0.200e3 * dq(3) * lmz3 * cos(q(3)));
C_31 = 0.2500000000e-4 * dq(1) * (0.17800e5 * m3 * lmx3 - 0.35600e5 * m3 * lmx3 * cos(q(2)) ^ 2 + 0.80000e5 * I3x * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.2800e4 * m3 * lmx3 * sin(q(2)) * sin(q(3)) + 0.2800e4 * m3 * lmx3 * cos(q(2)) * cos(q(3)) + 0.2800e4 * m3 * lmz3 * sin(q(2)) * cos(q(3)) + 0.2800e4 * m3 * lmz3 * cos(q(2)) * sin(q(3)) - 0.6408e4 * m3 * cos(q(2)) ^ 2 * cos(q(3)) + 0.15842e5 * m3 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.80000e5 * I3z * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.40000e5 * m3 * lmz3 ^ 2 * cos(q(2)) * sin(q(2)) - 0.35600e5 * m3 * lmz3 * cos(q(2)) * sin(q(2)) + 0.40000e5 * m3 * lmx3 ^ 2 * cos(q(2)) * sin(q(2)) + 0.6408e4 * m3 * cos(q(2)) * sin(q(3)) * sin(q(2)) + 0.80000e5 * m3 * lmz3 ^ 2 * cos(q(2)) ^ 2 * cos(q(3)) * sin(q(3)) + 0.71200e5 * m3 * lmz3 * cos(q(2)) ^ 2 * cos(q(3)) * sin(q(3)) - 0.80000e5 * m3 * lmx3 ^ 2 * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) + 0.160000e6 * m3 * lmx3 * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 * lmz3 - 0.71200e5 * m3 * lmx3 * cos(q(2)) * cos(q(3)) * sin(q(3)) * sin(q(2)) - 0.40000e5 * I3x * cos(q(2)) * sin(q(2)) + 0.1246e4 * m3 * cos(q(2)) * sin(q(3)) + 0.1246e4 * m3 * sin(q(2)) * cos(q(3)) - 0.7921e4 * m3 * cos(q(2)) * sin(q(2)) + 0.40000e5 * I3z * cos(q(2)) * sin(q(2)) - 0.40000e5 * I3x * cos(q(3)) * sin(q(3)) + 0.40000e5 * I3z * cos(q(3)) * sin(q(3)) - 0.7921e4 * m3 * cos(q(3)) * sin(q(3)) - 0.14400e5 * m3 * lmx3 * sin(q(3)) + 0.14400e5 * m3 * lmz3 * cos(q(3)) + 0.15842e5 * m3 * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.80000e5 * m3 * lmx3 * cos(q(2)) ^ 2 * lmz3 + 0.80000e5 * I3x * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.80000e5 * I3z * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) + 0.14400e5 * m3 * cos(q(2)) ^ 2 * lmx3 * sin(q(3)) - 0.14400e5 * m3 * cos(q(2)) ^ 2 * lmz3 * cos(q(3)) - 0.80000e5 * m3 * lmx3 ^ 2 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) + 0.80000e5 * m3 * lmz3 ^ 2 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) + 0.71200e5 * m3 * lmz3 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) + 0.14400e5 * m3 * lmx3 * cos(q(2)) * cos(q(3)) * sin(q(2)) + 0.14400e5 * m3 * lmz3 * cos(q(2)) * sin(q(3)) * sin(q(2)) + 0.71200e5 * m3 * lmx3 * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 - 0.80000e5 * m3 * lmx3 * cos(q(3)) ^ 2 * lmz3 - 0.160000e6 * m3 * lmx3 * cos(q(2)) * cos(q(3)) * lmz3 * sin(q(3)) * sin(q(2)) + 0.6408e4 * m3 * cos(q(3)) - 0.40000e5 * m3 * lmz3 ^ 2 * cos(q(3)) * sin(q(3)) - 0.35600e5 * m3 * lmz3 * cos(q(3)) * sin(q(3)) + 0.40000e5 * m3 * lmx3 ^ 2 * cos(q(3)) * sin(q(3)) - 0.35600e5 * m3 * lmx3 * cos(q(3)) ^ 2 + 0.40000e5 * m3 * lmx3 * lmz3);
C_32 = 0.1800000000e-2 * dq(2) * m3 * (0.89e2 * cos(q(3)) - 0.200e3 * lmx3 * sin(q(3)) + 0.200e3 * lmz3 * cos(q(3)));
C_33 = 0;

C_11_est = RBFNN_C_11.Calculate([q(2) q(3) (dq(2)+dq(3))]);
C_12_est = RBFNN_C_12.Calculate([q(2) q(3) (dq(1)+dq(2)+dq(3))]);%3
C_13_est = RBFNN_C_13.Calculate([q(2) q(3) (dq(1)+dq(2)+dq(3))]);%3
C_21_est = RBFNN_C_21.Calculate([dq(1) q(2) q(3)]);
C_22_est = RBFNN_C_22.Calculate([q(3) dq(3)]);
C_23_est = RBFNN_C_23.Calculate([q(3) (dq(2)+dq(3))]);
C_31_est = RBFNN_C_31.Calculate([(dq(1)+q(2)) q(3)]);
C_32_est = RBFNN_C_32.Calculate([dq(2) q(3)]);

C_11_err = C_11 - C_11_est;
C_12_err = C_12 - C_12_est;
C_13_err = C_13 - C_13_est;
C_21_err = C_21 - C_21_est;
C_22_err = C_22 - C_22_est;
C_23_err = C_23 - C_23_est;
C_31_err = C_31 - C_31_est;
C_32_err = C_32 - C_32_est;


DATA_C = [DATA_C, [C_11_err; C_12_err; C_13_err; C_21_err; C_22_err; C_23_err; C_31_err; C_32_err]];


RBFNN_C_11 = RBFNN_C_11.Train([q(2) q(3) (dq(2)+dq(3))], C_11_err);
RBFNN_C_12 = RBFNN_C_12.Train([q(2) q(3) (dq(1)+dq(2)+dq(3))], C_12_err);
RBFNN_C_13 = RBFNN_C_13.Train([q(2) q(3) (dq(1)+dq(2)+dq(3))], C_13_err);
RBFNN_C_21 = RBFNN_C_21.Train([dq(1) q(2) q(3)], C_21_err);
RBFNN_C_22 = RBFNN_C_22.Train([q(3) dq(3)], C_22_err);
RBFNN_C_23 = RBFNN_C_23.Train([q(3) (dq(2)+dq(3))], C_23_err);
RBFNN_C_31 = RBFNN_C_31.Train([(dq(1)+q(2)) q(3)], C_31_err);
RBFNN_C_32 = RBFNN_C_32.Train([dq(2) q(3)], C_32_err);


[C_11_est outp_C_11] = RBFNN_C_11.Calculate([q(2) q(3) (dq(2)+dq(3))]);
[C_12_est outp_C_12]= RBFNN_C_12.Calculate([q(2) q(3) (dq(1)+dq(2)+dq(3))]);
[C_13_est outp_C_13]= RBFNN_C_13.Calculate([q(2) q(3) (dq(1)+dq(2)+dq(3))]);
[C_21_est outp_C_21]= RBFNN_C_21.Calculate([dq(1) q(2) q(3)]);
[C_22_est outp_C_22]= RBFNN_C_22.Calculate([q(3) dq(3)]);
[C_23_est outp_C_23]= RBFNN_C_23.Calculate([q(3) (dq(2)+dq(3))]);
[C_31_est outp_C_31] = RBFNN_C_31.Calculate([(dq(1)+q(2)) q(3)]);
[C_32_est outp_C_32] = RBFNN_C_32.Calculate([dq(2) q(3)]);

act_outp_C_11 = act_outp_C_11 + outp_C_11;
act_outp_C_12 = act_outp_C_12 + outp_C_12;
act_outp_C_13 = act_outp_C_13 + outp_C_13;
act_outp_C_21 = act_outp_C_21 + outp_C_21;
act_outp_C_22 = act_outp_C_22 + outp_C_22;
act_outp_C_23 = act_outp_C_23 + outp_C_23;
act_outp_C_31 = act_outp_C_31 + outp_C_31;
act_outp_C_32 = act_outp_C_32 + outp_C_32;


if length(C_11_prun(1,:)) == 1
    C_prun_1 = 2;
else
    C_prun_1 = length(C_11_prun(1,:)) + 1;%iteration number
end

len = length(DATA_C);
%change here for the different pruning methods
%weight pruning from 2200-6600, node from 4400-8800(not necessary to end this)
if len > 4400 && len < 8800
    d1 = DATA_C(1, len-400:len);
    d2 = DATA_C(2, len-400:len);
    d3 = DATA_C(3, len-400:len);
    d4 = DATA_C(4, len-400:len);
    d5 = DATA_C(5, len-400:len);
    d6 = DATA_C(6, len-400:len);
    d7 = DATA_C(7, len-400:len);
    d8 = DATA_C(8, len-400:len);
    rms_C11 = Rmse(d1);
    rms_C12 = Rmse(d2);
    rms_C13 = Rmse(d3);
    rms_C21 = Rmse(d4);
    rms_C22 = Rmse(d5);
    rms_C23 = Rmse(d6);
    rms_C31 = Rmse(d7);
    rms_C32 = Rmse(d8);
    
    if rms_C11 < 0.01
        %prune by node output
        [RBFNN_C_11 act_outp_C_11 prunedO p_thO] = RBFNN_C_11.pruneO(act_outp_C_11, outp_th_C, 3);
        %prune by weight magnitude
        [RBFNN_C_11 n_prunC11 prunedW p_thW act_outp_C_11] = RBFNN_C_11.pruneW(weight_th_C, 3, n_prunW_C(1,1), act_outp_C_11);
        n_prunW_C(1,1) = n_prunC11;
       
        %store the pruning result
        C_11_prun_2 =  p_thW;
        if prunedW == 0 
            C_11_prun_3 = 0; 
        else
            C_11_prun_3 = length(prunedW);%units pruned by weight 
        end
        C_11_prun_4 =  p_thO;
        if prunedO == 0 
            C_11_prun_5 = 0; 
        else
            C_11_prun_5 = length(prunedO);%units pruned by node 
        end
        C_11_prun = [C_11_prun, [C_prun_1; C_11_prun_2; C_11_prun_3;C_11_prun_4;C_11_prun_5]];
    else%if the error is not small enough
        C_11_prun_2 = 0;
        C_11_prun_3 = 0;
        C_11_prun_4 = 0;
        C_11_prun_5 = 0;
        C_11_prun = [C_11_prun, [C_prun_1; C_11_prun_2; C_11_prun_3; C_11_prun_4; C_11_prun_5]];
    end
    
    
    if rms_C12 < 0.01
        %prune by node output
        [RBFNN_C_12 act_outp_C_12 prunedO p_thO] = RBFNN_C_12.pruneO(act_outp_C_12, outp_th_C, 3);
        %prune by weight magnitude
        [RBFNN_C_12 n_prunC12 prunedW p_thW act_outp_C_12] = RBFNN_C_12.pruneW(weight_th_C, 3, n_prunW_C(2,1), act_outp_C_12);
        n_prunW_C(2,1) = n_prunC12;
        
        %store the pruning result
        C_12_prun_2 =  p_thW;
        if prunedW == 0
            C_12_prun_3 = 0; 
        else
            C_12_prun_3 = length(prunedW);
        end
        C_12_prun_4 =  p_thO;
        if prunedO == 0 
            C_12_prun_5 = 0; 
        else
            C_12_prun_5 = length(prunedO);
        end
        C_12_prun = [C_12_prun, [C_prun_1; C_12_prun_2; C_12_prun_3; C_12_prun_4; C_12_prun_5]];
        
    else%if the error is not small enough
        C_12_prun_2 = 0;
        C_12_prun_3 = 0;
        C_12_prun_4 = 0;
        C_12_prun_5 = 0;
        C_12_prun = [C_11_prun, [C_prun_1; C_12_prun_2; C_12_prun_3; C_12_prun_4; C_12_prun_5]];       
    end
    
    if rms_C13 < 0.01
        %prune by node output
        [RBFNN_C_13 act_outp_C_13 prunedO p_thO] = RBFNN_C_13.pruneO(act_outp_C_13, outp_th_C, 3);
        %prune by weight magnitude
        [RBFNN_C_13 n_prunC13 prunedW p_thW act_outp_C_13] = RBFNN_C_13.pruneW(weight_th_C, 3, n_prunW_C(3,1), act_outp_C_13);
        n_prunW_C(3,1) = n_prunC13;
        
        %store the pruning result
        C_13_prun_2 =  p_thW;
        if prunedW == 0
            C_13_prun_3 = 0; 
        else
            C_13_prun_3 = length(prunedW);
        end
        C_13_prun_4 =  p_thO;
        if prunedO == 0 
            C_13_prun_5 = 0; 
        else
            C_13_prun_5 = length(prunedO);
        end
        C_13_prun = [C_13_prun, [C_prun_1; C_13_prun_2; C_13_prun_3; C_13_prun_4; C_13_prun_5]];
        
    else%if the error is not small enough
        C_13_prun_2 = 0;
        C_13_prun_3 = 0;
        C_13_prun_4 = 0;
        C_13_prun_5 = 0;
        C_13_prun = [C_13_prun, [C_prun_1; C_13_prun_2; C_13_prun_3; C_13_prun_4; C_13_prun_5]];       
    end
    
    
    if rms_C21 < 0.01
        %prune by node output
        [RBFNN_C_21 act_outp_C_21 prunedO p_thO] = RBFNN_C_21.pruneO(act_outp_C_21, outp_th_C, 3);
        %prune by weight magnitude
        [RBFNN_C_21 n_prunC21 prunedW p_thW act_outp_C_21]= RBFNN_C_21.pruneW(weight_th_C, 3, n_prunW_C(4,1), act_outp_C_21);
        %disp(['pruned RBFNN_C_21, units are ' num2str(length(RBFNN_C_21.mu))]);
        n_prunW_C(4,1) = n_prunC21;
        
        %store the pruning result
        C_21_prun_2 =  p_thW;
        if prunedW == 0 
            C_21_prun_3 = 0; 
        else
            C_21_prun_3 = length(prunedW);%units pruned by weight
        end
        C_21_prun_4 =  p_thO;
        if prunedO == 0 
            C_21_prun_5 = 0; 
        else
            C_21_prun_5 = length(prunedO);%units pruned by node
        end
        C_21_prun = [C_21_prun, [C_prun_1; C_21_prun_2; C_21_prun_3; C_21_prun_4; C_21_prun_5 ]];
        
    else%if the error is not small enough
        C_21_prun_2 = 0;
        C_21_prun_3 = 0;
        C_21_prun_4 = 0;
        C_21_prun_5 = 0;
        C_21_prun = [C_21_prun, [C_prun_1; C_21_prun_2; C_21_prun_3; C_21_prun_4; C_21_prun_5]];
    end
   
    if rms_C22 < 0.01
        %prune by node output
        [RBFNN_C_22 act_outp_C_22 prunedO p_thO] = RBFNN_C_22.pruneO(act_outp_C_22, outp_th_C, 2);
        %prune by weight magnitude
        [RBFNN_C_22 n_prunC22 prunedW p_thW act_outp_C_22]= RBFNN_C_22.pruneW(weight_th_C, 2, n_prunW_C(5,1), act_outp_C_22);
        %disp(['pruned RBFNN_C_22, units are ' num2str(length(RBFNN_C_22.mu))]);
        n_prunW_C(5,1) = n_prunC22;
        
        %store the pruning result
        C_22_prun_2 =  p_thW;
        if prunedW == 0 
            C_22_prun_3 = 0; 
        else
            C_22_prun_3 = length(prunedW);%units pruned by weight
        end
        C_22_prun_4 =  p_thO;
        if prunedO == 0 
            C_22_prun_5 = 0; 
        else
            C_22_prun_5 = length(prunedO);%units pruned by node
        end
        C_22_prun = [C_22_prun, [C_prun_1; C_22_prun_2; C_22_prun_3; C_22_prun_4; C_22_prun_5 ]];
        
    else%if the error is not small enough
        C_22_prun_2 = 0;
        C_22_prun_3 = 0;
        C_22_prun_4 = 0;
        C_22_prun_5 = 0;
        C_22_prun = [C_22_prun, [C_prun_1; C_22_prun_2; C_22_prun_3; C_22_prun_4; C_22_prun_5]];
    end
    
    
    if rms_C23 < 0.01
        %prune by node output
        [RBFNN_C_23 act_outp_C_23 prunedO p_thO] = RBFNN_C_23.pruneO(act_outp_C_23, outp_th_C, 2);
        %prune by weight magnitude
        [RBFNN_C_23 n_prunC23 prunedW p_thW act_outp_C_23]= RBFNN_C_23.pruneW(weight_th_C, 2, n_prunW_C(6,1), act_outp_C_23);
        %disp(['pruned RBFNN_C_23, units are ' num2str(length(RBFNN_C_23.mu))]);
        n_prunW_C(6,1) = n_prunC23;
        
        %store the pruning result
        C_23_prun_2 =  p_thW;
        if prunedW == 0 
            C_23_prun_3 = 0; 
        else
            C_23_prun_3 = length(prunedW);%units pruned by weight
        end
        C_23_prun_4 =  p_thO;
        if prunedO == 0 
            C_23_prun_5 = 0; 
        else
            C_23_prun_5 = length(prunedO);%units pruned by node
        end
        C_23_prun = [C_23_prun, [C_prun_1; C_23_prun_2; C_23_prun_3; C_23_prun_4; C_23_prun_5 ]];
        
    else%if the error is not small enough
        C_23_prun_2 = 0;
        C_23_prun_3 = 0;
        C_23_prun_4 = 0;
        C_23_prun_5 = 0;
        C_23_prun = [C_23_prun, [C_prun_1; C_23_prun_2; C_23_prun_3; C_23_prun_4; C_23_prun_5]];
    end
    
    
    if rms_C31 < 0.01
        %prune by node output
        [RBFNN_C_31 act_outp_C_31 prunedO p_thO] = RBFNN_C_31.pruneO(act_outp_C_31, outp_th_C, 2);
        %prune by weight magnitude
        [RBFNN_C_31 n_prunC31 prunedW p_thW act_outp_C_31]= RBFNN_C_31.pruneW(weight_th_C, 2, n_prunW_C(7,1), act_outp_C_31);
        %disp(['pruned RBFNN_C_31, units are ' num2str(length(RBFNN_C_31.mu))]);
        n_prunW_C(7,1) = n_prunC31;
        
        %store the pruning result
        C_31_prun_2 =  p_thW;
        if prunedW == 0 
            C_31_prun_3 = 0; 
        else
            C_31_prun_3 = length(prunedW);%units pruned by weight
        end
        C_31_prun_4 =  p_thO;
        if prunedO == 0 
            C_31_prun_5 = 0; 
        else
            C_31_prun_5 = length(prunedO);%units pruned by node
        end
        C_31_prun = [C_31_prun, [C_prun_1; C_31_prun_2; C_31_prun_3; C_31_prun_4; C_31_prun_5 ]];
        
    else%if the error is not small enough
        C_31_prun_2 = 0;
        C_31_prun_3 = 0;
        C_31_prun_4 = 0;
        C_31_prun_5 = 0;
        C_31_prun = [C_31_prun, [C_prun_1; C_31_prun_2; C_31_prun_3; C_31_prun_4; C_31_prun_5]];
    end
    
    
    if rms_C32 < 0.01
        %prune by node output
        [RBFNN_C_32 act_outp_C_32 prunedO p_thO] = RBFNN_C_32.pruneO(act_outp_C_32, outp_th_C, 2);
        %prune by weight magnitude
        [RBFNN_C_32 n_prunC32 prunedW p_thW act_outp_C_32]= RBFNN_C_32.pruneW(weight_th_C, 2, n_prunW_C(8,1), act_outp_C_32);
        %disp(['pruned RBFNN_C_32, units are ' num2str(length(RBFNN_C_32.mu))]);
        n_prunW_C(8,1) = n_prunC32;
        
        %store the pruning result
        C_32_prun_2 =  p_thW;
        if prunedW == 0 
            C_32_prun_3 = 0; 
        else
            C_32_prun_3 = length(prunedW);%units pruned by weight
        end
        C_32_prun_4 =  p_thO;
        if prunedO == 0 
            C_32_prun_5 = 0; 
        else
            C_32_prun_5 = length(prunedO);%units pruned by node
        end
        C_32_prun = [C_32_prun, [C_prun_1; C_32_prun_2; C_32_prun_3; C_32_prun_4; C_32_prun_5 ]];
        
    else%if the error is not small enough
        C_32_prun_2 = 0;
        C_32_prun_3 = 0;
        C_32_prun_4 = 0;
        C_32_prun_5 = 0;
        C_32_prun = [C_32_prun, [C_prun_1; C_32_prun_2; C_32_prun_3; C_32_prun_4; C_32_prun_5]];
    end
    
    
else  %not done enough iterations to prune  
    C_11_prun_2 = 0;
    C_11_prun_3 = 0;
    C_11_prun_4 = 0;
    C_11_prun_5 = 0;
    C_11_prun = [C_11_prun, [C_prun_1; C_11_prun_2; C_11_prun_3; C_11_prun_4; C_11_prun_5]];

    C_12_prun_2 = 0;
    C_12_prun_3 = 0;
    C_12_prun_4 = 0;
    C_12_prun_5 = 0;
    C_12_prun = [C_11_prun, [C_prun_1; C_12_prun_2; C_12_prun_3; C_12_prun_4; C_12_prun_5]];
        
    C_13_prun_2 = 0;
    C_13_prun_3 = 0;
    C_13_prun_4 = 0;
    C_13_prun_5 = 0;
    C_13_prun = [C_13_prun, [C_prun_1; C_13_prun_2; C_13_prun_3; C_13_prun_4; C_13_prun_5]];
    
    C_21_prun_2 = 0;
    C_21_prun_3 = 0;
    C_21_prun_4 = 0;
    C_21_prun_5 = 0;
    C_21_prun = [C_21_prun, [C_prun_1; C_21_prun_2; C_21_prun_3; C_21_prun_4; C_21_prun_5]];
    
    C_22_prun_2 = 0;
    C_22_prun_3 = 0;
    C_22_prun_4 = 0;
    C_22_prun_5 = 0;
    C_22_prun = [C_22_prun, [C_prun_1; C_22_prun_2; C_22_prun_3; C_22_prun_4; C_22_prun_5]];    
    
    C_23_prun_2 = 0;
    C_23_prun_3 = 0;
    C_23_prun_4 = 0;
    C_23_prun_5 = 0;
    C_23_prun = [C_23_prun, [C_prun_1; C_23_prun_2; C_23_prun_3; C_23_prun_4; C_23_prun_5]];

    C_31_prun_2 = 0;
    C_31_prun_3 = 0;
    C_31_prun_4 = 0;
    C_31_prun_5 = 0;
    C_31_prun = [C_31_prun, [C_prun_1; C_31_prun_2; C_31_prun_3; C_31_prun_4; C_31_prun_5]];
    
    C_32_prun_2 = 0;
    C_32_prun_3 = 0;
    C_32_prun_4 = 0;
    C_32_prun_5 = 0;
    C_32_prun = [C_32_prun, [C_prun_1; C_32_prun_2; C_32_prun_3; C_32_prun_4; C_32_prun_5]];
   
end 

C = [C_11_est C_12_est C_13_est; C_21_est C_22_est C_23_est; C_31_est C_32_est 0];

nC_11 = norm(RBFNN_C_11.w ,2);
nC_12 = norm(RBFNN_C_12.w ,2);
nC_13 = norm(RBFNN_C_13.w ,2);
nC_21 = norm(RBFNN_C_21.w ,2);
nC_22 = norm(RBFNN_C_22.w ,2);
nC_23 = norm(RBFNN_C_23.w ,2);
nC_31 = norm(RBFNN_C_31.w ,2);
nC_32 = norm(RBFNN_C_32.w ,2);

norm_C = [norm_C, [nC_11; nC_12; nC_13; nC_21; nC_22; nC_23; nC_31; nC_32]];


end