
%-----------------------------Plotting states---------------------------%
%first threshold 3% weight
[states] = load('states.mat');
[desiredTrajectory] = load('desiredTrajectory.mat');

t = states.ans.data(:,7);
q = states.ans.data(1:length(t),1:3);
dq = states.ans.data(1:length(t),4:6);
qd = desiredTrajectory.ans.data(1:length(t),1:3);
dqd = desiredTrajectory.ans.data(1:length(t),4:6);

%second threshold 5% weight
%[states_2] = load('states_5pW.mat');
%t_5pW = states_2.ans.data(:,7);
%q_5pW = states_2.ans.data(1:length(t_5pW),1:3);
%dq_5pW = states_2.ans.data(1:length(t_5pW),4:6);

%second threshold 30% Output
%[states_3] = load('states_30pO.mat');
%t_30pO = states_3.ans.data(:,7);
%q_30pO = states_3.ans.data(1:length(t_30pO),1:3);
%dq_30pO = states_3.ans.data(1:length(t_30pO),4:6);


figure;
subplot(1,3,1);
plot(t,qd(:,1),'r','linewidth',1.5);
grid on;
xlabel('t,[s]')
ylabel('q_1,[s]')
axis([0 20 -0.55 0.55])
title('Desired Trajectory q_1');
hold on

subplot(1,3,2);
plot(t,qd(:,2),'r','linewidth',1.5);
grid on;
xlabel('t,[s]')
ylabel('q_2,[s]')
axis([0 20 -0.8 0.8])
title('Desired Trajectory q_2');
hold on


subplot(1,3,3);
plot(t,qd(:,3),'r','linewidth',1);
grid on;
xlabel('t,[s]')
ylabel('q_3,[s]')
axis([0 20 -0.35 0.35])
title('Desired Trajectory q_3');
hold on

%------ desired and actual trajectory
figure;
subplot(1,3,1);
%plot(t,qd(:,1),'r','linewidth',1.5);
plot(t,qd(:,1),':','linewidth',1);
grid on;
xlabel('time [sec]')
ylabel('q_1')
axis([0 20 -0.55 0.55])
title('Trajectory q_1');
hold on
%plot(t,q(:,1),'linewidth',1);
plot(t,q(:,1),'--','linewidth',1);
%hold on
%plot(t_30pO,q_30pO(:,1),'g','linewidth',0.5)

subplot(1,3,2);
plot(t,qd(:,2),':','linewidth',1);
grid on;
xlabel('time [sec]')
ylabel('q_2')
axis([0 20 -0.8 0.8])
title('Trajectory q_2');
hold on
plot(t,q(:,2),'--','linewidth',1);
%hold on
%plot(t_30pO,q_30pO(:,2),'g','linewidth',0.5)
%legend('Desired Trajectory q_2', 'Actual Trajectory q_2')

subplot(1,3,3);
plot(t,qd(:,3),':','linewidth',1);
grid on;
xlabel('time [sec]')
ylabel('q_3')
axis([0 20 -0.4 0.4])
title('Trajectory q_3');
hold on
plot(t,q(:,3),'--','linewidth',1);
%hold on 
%plot(t_30pO,q_30pO(:,3),'g','linewidth',0.5)
%legend('Desired Trajectory', 'Trajectory 10%', 'Trajectory 30%')
legend('Desired Trajectory', 'Actual Trajectory')


%------------------Finding tracking errors------------
F = sum((abs(qd(:,1) - q(:,1)).^2)*(t(2) - t(1))) + sum((abs(qd(:,2) - q(:,2)).^2)*(t(2) - t(1))) + sum((abs(qd(:,3) - q(:,3)).^2)*(t(2) - t(1)));
%disp(['the F tracking error is ' num2str(F)]);

sse = sum( (qd(:,1) - q(:,1)).^2 ) + sum( (qd(:,2) - q(:,2)).^2 ) + sum( (qd(:,3) - q(:,3)).^2 );
disp(['the sse tracking error is ' num2str(sse)]);

it3pi = length(t);
it1pi = floor(it3pi/3);
sse_2 = sum( (qd(it3pi-it1pi:it3pi,1) - q(it3pi-it1pi:it3pi,1)).^2 ) + sum( (qd(it3pi-it1pi:it3pi,2) - q(it3pi-it1pi:it3pi,2)).^2 ) + sum( (qd(it3pi-it1pi:it3pi,3) - q(it3pi-it1pi:it3pi,3)).^2 );
disp(['the sse tracking error for the last 2pi sec of the long simulation is ' num2str(sse_2)]);



%---------------Finding approximation errors -------------------------------%

%for M matrix estimation
len = length(DATA_M);

rms_M11 = Rmse(DATA_M(1, len-300:len));
rms_M12 = Rmse(DATA_M(2, len-300:len));
rms_M13 = Rmse(DATA_M(3, len-300:len));
rms_M22 = Rmse(DATA_M(4, len-300:len));
rms_M23 = Rmse(DATA_M(5, len-300:len));
rms_M33 = Rmse(DATA_M(6, len-300:len));

rms_M = rms_M11 + rms_M12 + rms_M13 + rms_M22 + rms_M23 + rms_M33;

rms_M11_wh = Rmse(DATA_M(1,:));
rms_M12_wh = Rmse(DATA_M(2,:));
rms_M13_wh = Rmse(DATA_M(3,:));
rms_M22_wh = Rmse(DATA_M(4,:));
rms_M23_wh = Rmse(DATA_M(5,:));
rms_M33_wh = Rmse(DATA_M(6,:));

%figure();
%plot(DATA(1,:));
%title(['estimating error M11']);

%figure();
%plot(DATA(2,:));
%title(['estimating error M12']);

%figure();
%plot(DATA(3,:));
%title(['estimating error M21']);

%figure();
%plot(DATA(4,:));
%title(['estimating error M22']);

%for C matrix estimation
len_C = length(DATA_C);
rms_C11 = Rmse(DATA_C(1, len_C-300:len_C));
rms_C12 = Rmse(DATA_C(2, len_C-300:len_C));
rms_C13 = Rmse(DATA_C(3, len_C-300:len_C));
rms_C21 = Rmse(DATA_C(4, len_C-300:len_C));
rms_C22 = Rmse(DATA_C(5, len_C-300:len_C));
rms_C23 = Rmse(DATA_C(6, len_C-300:len_C));
rms_C31 = Rmse(DATA_C(7, len_C-300:len_C));
rms_C32 = Rmse(DATA_C(8, len_C-300:len_C));

rms_C = rms_C11+rms_C12+rms_C13+rms_C21+rms_C22+rms_C23+rms_C31+rms_C32;

rms_C11_wh = Rmse(DATA_C(1,:));
rms_C12_wh = Rmse(DATA_C(2,:));
rms_C13_wh = Rmse(DATA_C(3,:));
rms_C21_wh = Rmse(DATA_C(4,:));
rms_C22_wh = Rmse(DATA_C(5,:));
rms_C23_wh = Rmse(DATA_C(6,:));
rms_C31_wh = Rmse(DATA_C(7,:));
rms_C32_wh = Rmse(DATA_C(8,:));



%figure();
%plot(DATA_C(1,:));
%title(['estimating error C11']);

%figure();
%plot(DATA_C(2,:));
%title(['estimating error C12']);

%figure();
%plot(DATA_C(3,:));
%title(['estimating error C21']);

%figure(6);
%plot(DATA_C(4,:));
%title(['estimating error C22']);

%G matrix estimation
len_G = length(DATA_G);
rms_G2 = Rmse(DATA_G(1,len_G-300:len_G));
rms_G3 = Rmse(DATA_G(2,len_G-300:len_G));
rms_G = rms_G2 + rms_G3;
rms_G2_wh = Rmse(DATA_G(1,:));
rms_G3_wh = Rmse(DATA_G(2,:));

rms_all = rms_M + rms_C + rms_G;
%figure();
%plot(DATA_G(1,:));
%title(['estimating error G11']);

%figure();
%plot(DATA_G(2,:));
%title(['estimating error G12']);

%displaying the approximation error for the last 300 iterations
disp(['approximation error for the last 300 iterations and the whole simulation:']);
disp(['M11 - 300: ' num2str(rms_M11) ' and whole: ' num2str(rms_M11_wh)]);
disp(['M12 - 300: ' num2str(rms_M12) ' and whole: ' num2str(rms_M12_wh)]);
disp(['M13 - 300: ' num2str(rms_M13) ' and whole: ' num2str(rms_M13_wh)]);
disp(['M22 - 300: ' num2str(rms_M22) ' and whole: ' num2str(rms_M22_wh)]);
disp(['M23 - 300: ' num2str(rms_M23) ' and whole: ' num2str(rms_M23_wh)]);
disp(['M33 - 300: ' num2str(rms_M33) ' and whole: ' num2str(rms_M33_wh)]);


disp(['C11 - 300: ' num2str(rms_C11) ' and whole: ' num2str(rms_C11_wh)]);
disp(['C12 - 300: ' num2str(rms_C12) ' and whole: ' num2str(rms_C12_wh)]);
disp(['C13 - 300: ' num2str(rms_C13) ' and whole: ' num2str(rms_C13_wh)]);
disp(['C21 - 300: ' num2str(rms_C21) ' and whole: ' num2str(rms_C21_wh)]);
disp(['C22 - 300: ' num2str(rms_C22) ' and whole: ' num2str(rms_C22_wh)]);
disp(['C23 - 300: ' num2str(rms_C23) ' and whole: ' num2str(rms_C23_wh)]);
disp(['C31 - 300: ' num2str(rms_C31) ' and whole: ' num2str(rms_C31_wh)]);
disp(['C32 - 300: ' num2str(rms_C32) ' and whole: ' num2str(rms_C32_wh)]);

disp(['G2 - 300: ' num2str(rms_G2) ' and whole: ' num2str(rms_G2_wh)]);
disp(['G3 - 300: ' num2str(rms_G3) ' and whole: ' num2str(rms_G3_wh)]);

disp(['Sum M last 300 iteration: ' num2str(rms_M) ]);
disp(['Sum C last 300 iteration: ' num2str(rms_C) ]);
disp(['Sum G last 300 iteration: ' num2str(rms_G) ]);
disp(['Sum all last 300 iteration: ' num2str(rms_all) ]);

disp(['final NN sizes are: ' ]);
disp(['M11 - ' num2str(length(RBFNN_M_11.mu)) ]);
disp(['M12 - ' num2str(length(RBFNN_M_12.mu)) ]);
disp(['M13 - ' num2str(length(RBFNN_M_13.mu)) ]);
disp(['M22 - ' num2str(length(RBFNN_M_22.mu)) ]);
disp(['M23 - ' num2str(length(RBFNN_M_23.mu)) ]);
disp(['M33 - ' num2str(length(RBFNN_M_33.mu)) ]);

disp(['C11 - ' num2str(length(RBFNN_C_11.mu)) ]);
disp(['C12 - ' num2str(length(RBFNN_C_12.mu)) ]);
disp(['C13 - ' num2str(length(RBFNN_C_13.mu)) ]);
disp(['C21 - ' num2str(length(RBFNN_C_21.mu)) ]);
disp(['C22 - ' num2str(length(RBFNN_C_22.mu)) ]);
disp(['C23 - ' num2str(length(RBFNN_C_23.mu)) ]);
disp(['C31 - ' num2str(length(RBFNN_C_31.mu)) ]);
disp(['C32 - ' num2str(length(RBFNN_C_32.mu)) ]);

disp(['G2 - ' num2str(length(RBFNN_G_2.mu)) ]);
disp(['G3 - ' num2str(length(RBFNN_G_3.mu)) ]);

total_size_M = length(RBFNN_M_11.mu)+length(RBFNN_M_12.mu)+length(RBFNN_M_13.mu)+length(RBFNN_M_22.mu)+length(RBFNN_M_23.mu)+length(RBFNN_M_33.mu);
total_size_C = length(RBFNN_C_11.mu)+length(RBFNN_C_12.mu)+length(RBFNN_C_13.mu)+length(RBFNN_C_21.mu)+length(RBFNN_C_22.mu)+length(RBFNN_C_23.mu)+length(RBFNN_C_31.mu)+length(RBFNN_C_32.mu);
total_size_G = length(RBFNN_G_2.mu) + length(RBFNN_G_3.mu);

disp(['total number of hidden units: ' num2str(total_size_M+total_size_C+total_size_G) ]);


%--------------------------Plotting 2-norms of weights--------------------
figure;

subplot(2,4,1);
plot(norm_C(1,:));
grid on;
axis([0 14000 0 5])
title('C11');

subplot(2,4,2);
plot(norm_C(2,:));
grid on;
axis([0 14000 0 4])
title('C12');

subplot(2,4,3);
plot(norm_C(3,:));
grid on;
axis([0 14000 0 4])
title('C13');

subplot(2,4,4);
plot(norm_C(4,:));
grid on;
axis([0 14000 0 5])
title('C21');

subplot(2,4,5);
plot(norm_C(5,:));
grid on;
axis([0 14000 0 2])
title('C22');

subplot(2,4,6);
plot(norm_C(6,:));
grid on;
axis([0 14000 0 5])
title('C23');

subplot(2,4,7);
plot(norm_C(7,:));
grid on;
axis([0 14000 0 2])
title('C31');

subplot(2,4,8);
plot(norm_C(8,:));
grid on;
axis([0 14000 0 4])
title('C32');


figure;%M
subplot(2,3,1);
plot(norm_M(1,:));
grid on;
axis([0 14000 0 14])
title('M11');

subplot(2,3,2);
plot(norm_M(2,:));
grid on;
axis([0 14000 0 1.3])
title('M12');

subplot(2,3,3);
plot(norm_M(3,:));
grid on;
axis([0 14000 0 0.4])
title('M13');

subplot(2,3,4);
plot(norm_M(4,:));
grid on;
axis([0 14000 0 20])
title('M22');

subplot(2,3,5);
plot(norm_M(5,:));
grid on;
axis([0 14000 0 8])
title('M23');

subplot(2,3,6);
plot(norm_M(6,:));
grid on;

axis([0 14000 0 6])
title('M33');


figure;%G
subplot(1,2,1);
plot(norm_G(1,:));
grid on;
axis([0 14000 0 165])
title('G2');

subplot(1,2,2);
plot(norm_G(2,:));
grid on;
axis([0 14000 0 65])
title('G3');


%---------------------Finding when units are pruned-------------------
m11_1 = M_11_prun(1,:);
m11_2 = M_11_prun(2,:);
m11_3 = M_11_prun(3,:);
outp_pruned_m11 = sum(m11_3);

m12_1 = M_12_prun(1,:);
m12_2 = M_12_prun(2,:);
m12_3 = M_12_prun(3,:);
outp_pruned_m12 = sum(m12_3);

m13_1 = M_13_prun(1,:);
m13_2 = M_13_prun(2,:);
m13_3 = M_13_prun(3,:);
outp_pruned_m13 = sum(m13_3);

m22_1 = M_22_prun(1,:);
m22_2 = M_22_prun(2,:);
m22_3 = M_22_prun(3,:);
outp_pruned_m22 = sum(m22_3);

m23_1 = M_23_prun(1,:);
m23_2 = M_23_prun(2,:);
m23_3 = M_23_prun(3,:);
outp_pruned_m23 = sum(m23_3);

m33_1 = M_33_prun(1,:);
m33_2 = M_33_prun(2,:);
m33_3 = M_33_prun(3,:);
outp_pruned_m33 = sum(m33_3);

for i = 1 : length(M_11_prun(1,:))
    if M_11_prun(3,i) ~= 0
        disp(['M11: ' num2str(M_11_prun(3,i)) ' units pruned by Weight Magnitude at iteration ' num2str(M_11_prun(1,i))]);% ' with threshold ' num2str(m11_2(i))]);
    end
    if M_11_prun(5,i) ~= 0
        disp(['M11: ' num2str(M_11_prun(5,i)) ' units pruned by Node Output at iteration ' num2str(M_11_prun(1,i))]);% ' with threshold ' num2str(m11_2(i))]);
    end
    
    if M_12_prun(3,i) ~= 0
        disp(['M12: ' num2str(M_12_prun(3,i)) ' units pruned by Weight Magnitude at iteration ' num2str(M_12_prun(1,i))]);% ' with threshold ' num2str(m12_2(i))]);
    end
    if M_12_prun(5,i) ~= 0
        disp(['M12: ' num2str(M_12_prun(5,i)) ' units pruned by Node Output at iteration ' num2str(M_12_prun(1,i))]);% ' with threshold ' num2str(m12_2(i))]);
    end
    
    if M_13_prun(3,i) ~= 0
        disp(['M13 pruned ' num2str(M_13_prun(3,i)) ' units pruned by Weight Magnitude at iteration ' num2str(M_13_prun(1,i))]);%  ' with threshold ' num2str(M_13_prun(2,i))]);
    end  
    if M_13_prun(5,i) ~= 0
        disp(['M13: ' num2str(M_13_prun(5,i)) ' units pruned by Node Output at iteration ' num2str(M_13_prun(1,i))]);% ' with threshold ' num2str(m12_2(i))]);
    end
    
    if M_22_prun(3,i) ~= 0
        disp(['M22 pruned ' num2str(M_22_prun(3,i)) ' units pruned by Weight Magnitude at iteration ' num2str(M_22_prun(1,i)) ' with threshold ' num2str(M_22_prun(2,i))]);
    end
    if M_22_prun(5,i) ~= 0
        disp(['M22: ' num2str(M_22_prun(3,i)) ' units pruned by Node Output at iteration ' num2str(M_22_prun(1,i))]);% ' with threshold ' num2str(m22_2(i))]);
    end 
    
    if M_33_prun(3,i) ~= 0
        disp(['M33 pruned ' num2str(M_33_prun(3,i)) ' units pruned by Weight Magnitude at iteration ' num2str(M_33_prun(1,i))]);% ' with threshold ' num2str(M_33_prun(2,i))]);
    end
    if M_33_prun(5,i) ~= 0
        disp(['M33: ' num2str(M_33_prun(3,i)) ' units pruned by Node Output at iteration ' num2str(M_33_prun(1,i))]);% ' with threshold ' num2str(m22_2(i))]);
    end 
end


%figure();
%plot(m11_1, m11_2, m11_1, m11_3);
%legend('pruning threshold, p_th', 'number of units_pruned');
%title(['M_11']);

%figure();
%plot(m12_1, m12_2, m12_1, m12_3);
%legend('pruning threshold, p_th', 'number of units_pruned');
%title(['M_12']);

%figure();
%plot(m21_1, m21_2, m21_1, m21_3);
%legend('pruning threshold, p_th', 'number of units_pruned');
%title(['M_21']);

%figure();
%plot(m22_1, m22_2, m22_1, m22_3);
%legend('pruning threshold, p_th', 'number of units_pruned');
%title(['M_22']);

c11_1 = C_11_prun(1,:);
c11_2 = C_11_prun(2,:);
c11_3 = C_11_prun(3,:);

c12_1 = C_12_prun(1,:);
c12_2 = C_12_prun(2,:);
c12_3 = C_12_prun(3,:);

c21_1 = C_21_prun(1,:);
c21_2 = C_21_prun(2,:);
c21_3 = C_21_prun(3,:);

outp_pruned_c11 = sum(C_11_prun(3,:));
outp_pruned_c12 = sum(C_12_prun(3,:));
outp_pruned_c13 = sum(C_13_prun(3,:));
outp_pruned_c21 = sum(C_21_prun(3,:));
outp_pruned_c22 = sum(C_22_prun(3,:));
outp_pruned_c23 = sum(C_23_prun(3,:));
outp_pruned_c31 = sum(C_31_prun(3,:));
outp_pruned_c32 = sum(C_32_prun(3,:));

outp_pruned_g2 = sum(G_2_prun(3,:));
outp_pruned_g3 = sum(G_3_prun(3,:));

%disp(['M11 pruned ' num2str(outp_pruned_m11) ' units by output pruning ']);
%disp(['M12 pruned ' num2str(outp_pruned_m12) ' units by output pruning ']);
%disp(['M13 pruned ' num2str(outp_pruned_m13) ' units by output pruning ']);
%disp(['M22 pruned ' num2str(outp_pruned_m22) ' units by output pruning ']);
%disp(['M23 pruned ' num2str(outp_pruned_m23) ' units by output pruning ']);
%disp(['M33 pruned ' num2str(outp_pruned_m33) ' units by output pruning ']);

%disp(['C11 pruned ' num2str(outp_pruned_c11) ' units by output pruning ']);
%disp(['C12 pruned ' num2str(outp_pruned_c12) ' units by output pruning ']);
%disp(['C13 pruned ' num2str(outp_pruned_c13) ' units by output pruning ']);
%disp(['C21 pruned ' num2str(outp_pruned_c21) ' units by output pruning ']);
%disp(['C22 pruned ' num2str(outp_pruned_c22) ' units by output pruning ']);
%disp(['C23 pruned ' num2str(outp_pruned_c23) ' units by output pruning ']);
%disp(['C31 pruned ' num2str(outp_pruned_c31) ' units by output pruning ']);
%disp(['C32 pruned ' num2str(outp_pruned_c32) ' units by output pruning ']);

%disp(['G2 pruned ' num2str(outp_pruned_g2) ' units by output pruning ']);
%disp(['G3 pruned ' num2str(outp_pruned_g3) ' units by output pruning ']);
for i = 1 : length(C_11_prun(1,:))
    if C_11_prun(3,i) ~= 0
        disp(['C11: ' num2str(C_11_prun(3,i)) ' units pruned by Weight Magnitude at iteration ' num2str(C_11_prun(1,i))]);% ' with threshold ' num2str(C_11_prun(2,i))]);
    end
    if C_11_prun(5,i) ~= 0
        disp(['C11: ' num2str(C_11_prun(5,i)) ' units pruned by Node Output at iteration ' num2str(C_11_prun(1,i))]);% ' with threshold ' num2str(C_11_prun(4,i))]);
    end
    
    if C_12_prun(3,i) ~= 0
        disp(['C12: ' num2str(C_12_prun(3,i)) ' units pruned by Weight Magnitude at iteration ' num2str(C_12_prun(1,i))]);% ' with threshold ' num2str(C_12_prun(2,i))]);
    end
    if C_12_prun(5,i) ~= 0
        disp(['C12: ' num2str(C_12_prun(5,i)) ' units pruned by Node Output at iteration ' num2str(C_12_prun(1,i))]);% ' with threshold ' num2str(C_12_prun(4,i))]);
    end   
    
    if C_13_prun(3,i) ~= 0
        disp(['C13: ' num2str(C_13_prun(3,i)) ' units pruned by Weight Magnitude at iteration ' num2str(C_13_prun(1,i))]);%  ' with threshold ' num2str(C_13_prun(2,i))]);
    end  
    if C_13_prun(5,i) ~= 0
        disp(['C13: ' num2str(C_13_prun(5,i)) ' units pruned by Node Output at iteration ' num2str(C_13_prun(1,i))]);%  ' with threshold ' num2str(C_13_prun(2,i))]);
    end 
    
    if C_21_prun(3,i) ~= 0
        disp(['C21: ' num2str(C_21_prun(3,i)) ' units pruned by Weight Magnitude at iteration ' num2str(C_21_prun(1,i))]);% ' with threshold ' num2str(C_21_prun(2,i))]);
    end    
    if C_21_prun(5,i) ~= 0
        disp(['C21: ' num2str(C_21_prun(5,i)) ' units pruned by Node Output at iteration ' num2str(C_21_prun(1,i))]);% ' with threshold ' num2str(C_21_prun(4,i))]);
    end  
    
    if C_22_prun(3,i) ~= 0
        disp(['C22: ' num2str(C_22_prun(3,i)) ' units pruned by Weight Magnitude at iteration ' num2str(C_22_prun(1,i))]);% ' with threshold ' num2str(C_22_prun(2,i))]);
    end
    if C_21_prun(5,i) ~= 0
        disp(['C22: ' num2str(C_22_prun(5,i)) ' units pruned by Node Output at iteration ' num2str(C_22_prun(1,i))]);% ' with threshold ' num2str(C_22_prun(4,i))]);
    end  
    
    if C_23_prun(3,i) ~= 0
        disp(['C23: ' num2str(C_23_prun(3,i)) ' units pruned by Weight Magnitude at iteration ' num2str(C_23_prun(1,i))]);%  ' with threshold ' num2str(C_23_prun(2,i))]);
    end    
    if C_23_prun(5,i) ~= 0
        disp(['C23: ' num2str(C_23_prun(5,i)) ' units pruned by Node Output at iteration ' num2str(C_23_prun(1,i))]);% ' with threshold ' num2str(C_23_prun(4,i))]);
    end  
    
    if C_31_prun(3,i) ~= 0
        disp(['C31: ' num2str(C_31_prun(3,i)) ' units pruned by Weight Magnitude at iteration ' num2str(C_31_prun(1,i))]);% ' with threshold ' num2str(C_31_prun(2,i))]);
    end    
    if C_31_prun(5,i) ~= 0
        disp(['C31: ' num2str(C_31_prun(5,i)) ' units pruned by Node Output at iteration ' num2str(C_31_prun(1,i))]);% ' with threshold ' num2str(C_31_prun(4,i))]);
    end 
    
    if C_32_prun(3,i) ~= 0
        disp(['C32: ' num2str(C_32_prun(3,i)) ' units pruned by Weight Magnitude at iteration ' num2str(C_32_prun(1,i))]);%  ' with threshold ' num2str(C_32_prun(2,i))]);
    end
     if C_32_prun(5,i) ~= 0
        disp(['C32: ' num2str(C_32_prun(5,i)) ' units pruned by Node Output at iteration ' num2str(C_32_prun(1,i))]);% ' with threshold ' num2str(C_32_prun(4,i))]);
    end    
end

%figure();
%plot(c11_1, c11_2, c11_1, c11_3);
%legend('pruning threshold, p_th', 'number of units_pruned');
%title(['C_11']);

%figure();
%plot(c12_1, c12_2, c12_1, c12_3);
%legend('pruning threshold, p_th', 'number of units_pruned');
%title(['C_12']);

%figure();
%plot(c21_1, c21_2, c21_1, c21_3);
%legend('pruning threshold, p_th', 'number of units_pruned');
%title(['C_21']);




for i = 1 : length(G_2_prun(1,:))
    if G_2_prun(3,i) ~= 0
        disp(['G2 pruned ' num2str(G_2_prun(3,i)) ' units pruned by Weight Magnitude at iteration ' num2str(G_2_prun(1,i))]);%  ' with threshold ' num2str(G_2_prun(2,i))]);
    end  
    if G_2_prun(5,i) ~= 0
        disp(['G2: ' num2str(G_2_prun(5,i)) ' units pruned by Node Output at iteration ' num2str(G_2_prun(1,i))]);% ' with threshold ' num2str(G_2_prun(4,i))]);
    end  
    
    if G_3_prun(3,i) ~= 0
        disp(['G3 pruned ' num2str(G_3_prun(3,i)) ' units pruned by Weight Magnitude at iteration ' num2str(G_3_prun(1,i))]);%  ' with threshold ' num2str(G_3_prun(2,i))]);
    end    
    if G_3_prun(5,i) ~= 0
        disp(['G3: ' num2str(G_3_prun(5,i)) ' units pruned by Node Output at iteration ' num2str(G_3_prun(1,i))]);% ' with threshold ' num2str(G_3_prun(4,i))]);
    end
end

%figure();
%plot(g11_1, g11_2, g11_1, g11_3);
%legend('pruning threshold, p_th', 'number of units_pruned');
%title(['G_11']);

%figure();
%plot(g12_1, g12_2, g12_1, g12_3);
%legend('pruning threshold, p_th', 'number of units_pruned');
%title(['G_12']);