%framework from Stepan Pchelkin

function Out = DynamicsOfManipulator(u)
%Returns qdot and qddot for the manipulator. Choose here if friction and
%disturbance should be included or not.

tau = u(1:3);
q = u(4:6);
dq = u(7:9);

Mt = M(q);
Ct = C(q,dq);
Gt = G(q);

%friction and disturbance
Ft = [1.2*dq(1); 1.4*dq(2); 0.8*dq(3)];%F(dq);
d = [3; 5; 4];

Deriv=dq;

DDots = (Mt)\(tau - Ct * Deriv - Gt - Ft - d);

Out = [Deriv; DDots];

end