function G = G_hat(q)
%Finds the estimaion of G(q) by using RBFNN with pruning

global m2 m3;
global lmx2 lmy2;
global lmx3 lmz3;

%RBF networks
global RBFNN_G_2 RBFNN_G_3;
%pruning thresholds 
global outp_th_G weight_th_G; 
%counter for number of times network pruned by weight pruning
global n_prunW_G;
%stores the network's estimation errors, weights norm
global DATA_G norm_G;
%activation function output ratio sums
global act_outp_G_2 act_outp_G_3;
%stores iteration number, p_thW, prunedW, p_thO, prunedO
global G_2_prun G_3_prun;


G_2 = m2 * (-0.981e1 * sin(q(2)) * lmx2 - 0.981e1 * cos(q(2)) * lmy2 - 0.353160e1 * sin(q(2))) + m3 * (0.981e1 * (cos(q(2)) * sin(q(3)) + sin(q(2)) * cos(q(3))) * lmx3 + 0.981e1 * (-cos(q(2)) * cos(q(3)) + sin(q(2)) * sin(q(3))) * lmz3 - 0.981e1 * (-0.445e0 * sin(q(3)) + 0.360e0) * sin(q(2)) - 0.436545e1 * cos(q(2)) * cos(q(3)));
G_3 = m3 * (0.981e1 * (cos(q(2)) * sin(q(3)) + sin(q(2)) * cos(q(3))) * lmx3 + 0.981e1 * (-cos(q(2)) * cos(q(3)) + sin(q(2)) * sin(q(3))) * lmz3 - 0.436545e1 * cos(q(2)) * cos(q(3)) + 0.436545e1 * sin(q(2)) * sin(q(3)));

G_2_est = RBFNN_G_2.Calculate([q(2) q(3)]);
G_3_est = RBFNN_G_3.Calculate([q(2) q(3)]);

%disp('in G.m, done first calculation');

G_2_err = G_2 - G_2_est;
G_3_err = G_3 - G_3_est;

DATA_G = [DATA_G, [G_2_err; G_3_err]];

RBFNN_G_2 = RBFNN_G_2.Train([q(2) q(3)], G_2_err);
RBFNN_G_3 = RBFNN_G_3.Train([q(2) q(3)], G_3_err);
%disp('in G.m, done first training');
[G_2_est outp_G_2] = RBFNN_G_2.Calculate([q(2) q(3)]);
[G_3_est outp_G_3] = RBFNN_G_3.Calculate([q(2) q(3)]);
%disp('in G.m, done second calculation');
act_outp_G_2 = act_outp_G_2 + outp_G_2;
act_outp_G_3 = act_outp_G_3 + outp_G_3;

if length(G_2_prun(1,:)) == 1
    G_2_prun_1 = 2;
    G_3_prun_1 = 2;
else
    G_2_prun_1 = length(G_2_prun(1,:)) + 1;%simulation iteration number
    G_3_prun_1 = length(G_3_prun(1,:)) + 1;
end
%disp('in G.m, iteration number');
len = length(DATA_G);
%change here for the different pruning methods
%weight pruning from 2200-6600, node from 4400-8800(not necessary to end
%this)
if len > 2200 && len < 6600
    
    d2_G = DATA_G(1, len-400:len);
    d3_G = DATA_G(2, len-400:len);
    rms_G2 = Rmse(d2_G);
    rms_G3 = Rmse(d3_G);
    
    if rms_G2 < 0.05
        %prune by node output
        [RBFNN_G_2 act_outp_G_2 prunedO p_thO] = RBFNN_G_2.pruneO(act_outp_G_2, outp_th_G, 2);
        %prune by weight magnitude
        [RBFNN_G_2 n_prunG2 prunedW p_thW act_outp_G_2] = RBFNN_G_2.pruneW(weight_th_G, 2, n_prunW_G(1,1), act_outp_G_2);
        n_prunW_G(1,1) = n_prunG2;

        %store the pruning result
        G_2_prun_2 =  p_thW;
        if prunedW == 0 
            G_2_prun_3 = 0; 
        else
            G_2_prun_3 = length(prunedW);
        end
        G_2_prun_4 =  p_thO;
        if prunedO == 0
            G_2_prun_5 = 0; 
        else
            G_2_prun_5 = length(prunedO);
        end
        G_2_prun = [G_2_prun, [G_2_prun_1; G_2_prun_2; G_2_prun_3; G_2_prun_4; G_2_prun_5]];
        
    else%if the error is too big for pruning
        G_2_prun_2 = 0;
        G_2_prun_3 = 0;
        G_2_prun_4 = 0;
        G_2_prun_5 = 0;        
        G_2_prun = [G_2_prun, [G_2_prun_1; G_2_prun_2; G_2_prun_3; G_2_prun_4; G_2_prun_5]]; 
    end
    
    if rms_G3 < 0.01
        %prune by node output
        [RBFNN_G_3 act_outp_G_3  prunedO p_thO] = RBFNN_G_3.pruneO(act_outp_G_3, outp_th_G, 2);
        [RBFNN_G_3 n_prunG3 prunedW p_thW act_outp_G_3] = RBFNN_G_3.pruneW(weight_th_G, 2, n_prunW_G(2,1), act_outp_G_3);
        n_prunW_G(2,1) = n_prunG3;
        
        %store the pruning result
        G_3_prun_2 =  p_thW;
        if prunedW == 0 
            G_3_prun_3 = 0; 
        else
            G_3_prun_3 = length(prunedW);
        end
        G_3_prun_4 =  p_thO;
        if prunedO == 0
            G_3_prun_5 = 0; 
        else
            G_3_prun_5 = length(prunedO);
        end
        G_3_prun = [G_3_prun, [G_3_prun_1; G_3_prun_2; G_3_prun_3; G_3_prun_4; G_3_prun_5]];
        
    else%if the error too big for pruning
        G_3_prun_2 = 0;
        G_3_prun_3 = 0;
        G_3_prun_4 = 0;
        G_3_prun_5 = 0;
        G_3_prun = [G_3_prun, [G_3_prun_1; G_3_prun_2; G_3_prun_3; G_3_prun_4; G_3_prun_5]]; 
    end
    
else%not done enough iterations
    G_2_prun_2 = 0;
    G_2_prun_3 = 0;
    G_2_prun_4 = 0;
    G_2_prun_5 = 0;        
    G_2_prun = [G_2_prun, [G_2_prun_1; G_2_prun_2; G_2_prun_3; G_2_prun_4; G_2_prun_5]]; 
    
    G_3_prun_2 = 0;
    G_3_prun_3 = 0;
    G_3_prun_4 = 0;
    G_3_prun_5 = 0;
    G_3_prun = [G_3_prun, [G_3_prun_1; G_3_prun_2; G_3_prun_3; G_3_prun_4; G_3_prun_5]];

end 

G = [0; G_2_est; G_3_est];

nG_2 = norm(RBFNN_G_2.w,2);
nG_3 = norm(RBFNN_G_3.w,2);

norm_G = [norm_G, [nG_2; nG_3]];

end %function