clc
close all
clear all
%-----------------------------Model values------------------------------%
load K;

global m1, m1 = K(1);
global m2, m2 = K(2);
global m3, m3 = K(3);
global lmx1, lmx1 = K(4);
global lmz1, lmz1 = K(5);
global lmx2, lmx2 = K(6);
global lmy2, lmy2 = K(7);
global lmz2, lmz2 = K(8);
global lmx3, lmx3 = K(9);
global lmy3, lmy3 = K(10);
global lmz3, lmz3 = K(11);
global I1y, I1y = K(12);
global I2x, I2x = K(13);
global I2y, I2y = K(14);
global I2z, I2z = K(15);
global I3x, I3x = K(16);
global I3y, I3y = K(17);
global I3z, I3z = K(18);
%then 19-24 are friction coeficients
%-----------------------------------------------------------------------%


%-----------------------------M matrix init------------------------------%

%initializing the RBF networks
global RBFNN_M_11, RBFNN_M_11 = MRL.RBFN(2, 1, -pi, pi, 0.75, -pi, pi, 0.75);%dep. on q2, q3
global RBFNN_M_12, RBFNN_M_12 = MRL.RBFN(2, 1, -pi, pi, 0.75, -pi, pi, 0.75);%dep. on q2, q3
global RBFNN_M_13, RBFNN_M_13 = MRL.RBFN(2, 1, -pi, pi, 0.75, -pi, pi, 0.75);%dep. on q2, q3
global RBFNN_M_22, RBFNN_M_22 = MRL.RBFN(1, 1, -pi, pi, 0.75);%dep. on q3
global RBFNN_M_23, RBFNN_M_23 = MRL.RBFN(1, 1, -pi, pi, 0.75);%dep. on q3
global RBFNN_M_33, RBFNN_M_33 = MRL.RBFN(1, 1, -pi, pi, 0.75);%dep on nothing

%estimation error each network during the simulation
global DATA_M, DATA_M = zeros(6,1); 
%how the weights norm for each network develop during the simulation
global norm_M, norm_M = zeros(6,1);

%activation function ratio output sums 
global act_outp_M_11, act_outp_M_11 = zeros(length(RBFNN_M_11.mu),1);
global act_outp_M_12, act_outp_M_12 = zeros(length(RBFNN_M_12.mu),1);
global act_outp_M_13, act_outp_M_13 = zeros(length(RBFNN_M_13.mu),1);
global act_outp_M_22, act_outp_M_22 = zeros(length(RBFNN_M_22.mu),1);
global act_outp_M_23, act_outp_M_23 = zeros(length(RBFNN_M_23.mu),1);
global act_outp_M_33, act_outp_M_33 = zeros(length(RBFNN_M_33.mu),1);

%iteration number, p_thW, prunedW, pthO, prunedO
global M_11_prun, M_11_prun = zeros(5,1);
global M_12_prun, M_12_prun = zeros(5,1);
global M_13_prun, M_13_prun = zeros(5,1);
global M_22_prun, M_22_prun = zeros(5,1);
global M_23_prun, M_23_prun = zeros(5,1);
global M_33_prun, M_33_prun = zeros(5,1);
%----------------------------------------------------------------------%


%-----------------------------C matrix init------------------------------%

%initializing the RBF networks
global RBFNN_C_11, RBFNN_C_11 = MRL.RBFN(3, 1, -pi, pi, 0.75, -pi, pi, 0.75, -pi, pi, 0.75);%dep on q2, dq2, q3, dq3
global RBFNN_C_12, RBFNN_C_12 = MRL.RBFN(3, 1, -pi, pi, 0.75, -pi, pi, 0.75, -pi, pi, 0.75);%dep on dq1, q2, dq2, q3, dq3 
global RBFNN_C_13, RBFNN_C_13 = MRL.RBFN(3, 1, -pi, pi, 0.75, -pi, pi, 0.75, -pi, pi, 0.75);%dep on dq1, q2, dq2, q3, dq3
global RBFNN_C_21, RBFNN_C_21 = MRL.RBFN(3, 1, -pi, pi, 0.75, -pi, pi, 0.75, -pi, pi, 0.75);%dep on dq1, q2, q3
global RBFNN_C_22, RBFNN_C_22 = MRL.RBFN(2, 1, -pi, pi, 0.75, -pi, pi, 0.75);%dep on q3, dq3
global RBFNN_C_23, RBFNN_C_23 = MRL.RBFN(2, 1, -pi, pi, 0.75, -pi, pi, 0.75);%dep on dq2, q2, dq3
global RBFNN_C_31, RBFNN_C_31 = MRL.RBFN(2, 1, -pi, pi, 0.75, -pi, pi, 0.75);%dep on dq1, q2, q3
global RBFNN_C_32, RBFNN_C_32 = MRL.RBFN(2, 1, -pi, pi, 0.75, -pi, pi, 0.75);%dep on dq2, q3

%how the weights norm for each network develop during the simulation
global norm_C, norm_C = zeros(8,1);
%estimation error each network during the simulation
global DATA_C, DATA_C = zeros(8,1);

%activation function ratio output sums 
global act_outp_C_11, act_outp_C_11 = zeros(length(RBFNN_C_11.mu),1);
global act_outp_C_12, act_outp_C_12 = zeros(length(RBFNN_C_12.mu),1);
global act_outp_C_13, act_outp_C_13 = zeros(length(RBFNN_C_13.mu),1);
global act_outp_C_21, act_outp_C_21 = zeros(length(RBFNN_C_21.mu),1); 
global act_outp_C_22, act_outp_C_22 = zeros(length(RBFNN_C_22.mu),1);
global act_outp_C_23, act_outp_C_23 = zeros(length(RBFNN_C_23.mu),1);
global act_outp_C_31, act_outp_C_31 = zeros(length(RBFNN_C_31.mu),1);
global act_outp_C_32, act_outp_C_32 = zeros(length(RBFNN_C_32.mu),1);

%iteration number, p_thW, prunedW, pthO, prunedO
global C_11_prun, C_11_prun = zeros(5,1);
global C_12_prun, C_12_prun = zeros(5,1);
global C_13_prun, C_13_prun = zeros(5,1);
global C_21_prun, C_21_prun = zeros(5,1);
global C_22_prun, C_22_prun = zeros(5,1);
global C_23_prun, C_23_prun = zeros(5,1);
global C_31_prun, C_31_prun = zeros(5,1);
global C_32_prun, C_32_prun = zeros(5,1);
%----------------------------------------------------------------------%


%-----------------------------G matrix init------------------------------%

%initializing the RBF networks
global RBFNN_G_2, RBFNN_G_2 = MRL.RBFN(2, 1, -pi, pi, 0.75, -pi, pi, 0.75); %dep on q2, q3
global RBFNN_G_3, RBFNN_G_3 = MRL.RBFN(2, 1, -pi, pi, 0.75, -pi, pi, 0.75);%dep on q2, q3

%how the matrix norm changes over time
global norm_G, norm_G = zeros(2,1); 
%all the approximation errors
global DATA_G, DATA_G = zeros(2,1);

global act_outp_G_2, act_outp_G_2 = zeros(length(RBFNN_G_2.mu),1);
global act_outp_G_3, act_outp_G_3 = zeros(length(RBFNN_G_3.mu),1);

%iteration number, p_thW, prunedW, pthO, prunedO
global G_2_prun, G_2_prun = zeros(5,1);
global G_3_prun, G_3_prun = zeros(5,1);
%----------------------------------------------------------------------%

%thresholds in percent for pruning
global outp_th_M, outp_th_M = 0.0;
global weight_th_M, weight_th_M = 0.07;
global outp_th_C, outp_th_C = 0.3;
global weight_th_C, weight_th_C = 0.0;
global outp_th_G, outp_th_G = 0.0; 
global weight_th_G, weight_th_G = 0.05;

%times there have been pruned units with pruneW, for weight pruning threshold
global n_prunW_M, n_prunW_M = ones(6,1); 
global n_prunW_C, n_prunW_C = ones(8,1); 
global n_prunW_G, n_prunW_G = ones(2,1); 

global display, display = 0;
global display_C, display_C = 0;

%gains for the inverse kinematic controller
global Kp Kd

Kp = diag([350,450,450]);
Kd = diag([2.5,4,2.5]);

% Initial position of manipulator arm x0 = [q1; q2; dq1; dq2]
x0 = [0; 0; 0; 0; 0; 0];

%------------------displaying initial networks-------------------------
disp(['starting NN sizes are: ' ]);
disp(['M11 - ' num2str(length(RBFNN_M_11.mu)) ]);
disp(['M12 - ' num2str(length(RBFNN_M_12.mu)) ]);
disp(['M13 - ' num2str(length(RBFNN_M_13.mu)) ]);
disp(['M22 - ' num2str(length(RBFNN_M_22.mu)) ]);
disp(['M23 - ' num2str(length(RBFNN_M_23.mu)) ]);
disp(['M33 - ' num2str(length(RBFNN_M_33.mu)) ]);

disp(['C11 - ' num2str(length(RBFNN_C_11.mu)) ]);
disp(['C12 - ' num2str(length(RBFNN_C_12.mu)) ]);
disp(['C13 - ' num2str(length(RBFNN_C_13.mu)) ]);
disp(['C21 - ' num2str(length(RBFNN_C_21.mu)) ]);
disp(['C22 - ' num2str(length(RBFNN_C_22.mu)) ]);
disp(['C23 - ' num2str(length(RBFNN_C_23.mu)) ]);
disp(['C31 - ' num2str(length(RBFNN_C_31.mu)) ]);
disp(['C32 - ' num2str(length(RBFNN_C_32.mu)) ]);

disp(['G2 - ' num2str(length(RBFNN_G_2.mu)) ]);
disp(['G3 - ' num2str(length(RBFNN_G_3.mu)) ]);

