function M = M_hat(q)
%Finds the estimation of M(q) by using RBFNN with pruning

global m1 m2 m3;
global lmx1 lmz1;
global lmx2 lmy2 lmz2;
global lmx3 lmy3 lmz3;
global I1y;
global I2x I2y I2z;
global I3x I3y I3z;

%RBF networks
global RBFNN_M_11 RBFNN_M_12 RBFNN_M_13 RBFNN_M_22 RBFNN_M_23 RBFNN_M_33;
%stores the network's estimation errors
global DATA_M; 
%stores the weight norm for the different networks
global norm_M;
%activation function output ratio sums
global act_outp_M_11 act_outp_M_12 act_outp_M_13 act_outp_M_22 act_outp_M_23 act_outp_M_33;
%pruning thresholds 
global weight_th_M outp_th_M;
%counter for number of times network pruned by weight pruning
global n_prunW_M; 
%stores iteration number, p_thW, prunedW, p_thO, prunedO
global M_11_prun M_12_prun M_13_prun M_22_prun M_23_prun M_33_prun;


M_11 = -0.3960500000e0 * m3 * cos(q(2)) * sin(q(3)) * sin(q(2)) * cos(q(3)) + 0.2e1 * m3 * lmx3 * cos(q(3)) * lmz3 * sin(q(3)) + 0.2e1 * m3 * lmx3 * sin(q(2)) * lmz3 * cos(q(2)) + 0.8900000000e0 * m3 * lmx3 * cos(q(2)) * sin(q(2)) + 0.4900000000e-2 * m1 + 0.1345000000e0 * m2 + m3 * lmz3 ^ 2 + 0.8900000000e0 * m3 * lmz3 - 0.2e1 * m3 * lmz3 ^ 2 * cos(q(2)) * cos(q(3)) * sin(q(2)) * sin(q(3)) - 0.1780000000e1 * m3 * lmz3 * cos(q(2)) * cos(q(3)) * sin(q(2)) * sin(q(3)) + 0.2e1 * m3 * lmx3 ^ 2 * cos(q(2)) * sin(q(3)) * sin(q(2)) * cos(q(3)) + m2 * lmx2 ^ 2 + 0.7200000000e0 * m2 * lmx2 + 0.2e1 * I3x * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 - 0.2e1 * I3x * cos(q(2)) * sin(q(3)) * sin(q(2)) * cos(q(3)) + 0.2e1 * I3z * cos(q(2)) * sin(q(3)) * sin(q(2)) * cos(q(3)) + 0.7200000000e0 * m2 * cos(q(2)) * lmy2 * sin(q(2)) + m1 * lmx1 ^ 2 + 0.1400000000e0 * m1 * lmx1 + m1 * lmz1 ^ 2 + m2 * lmz2 ^ 2 + m3 * lmy3 ^ 2 + 0.2e1 * m2 * cos(q(2)) * lmx2 * sin(q(2)) * lmy2 + 0.5040000000e-1 * m2 * sin(q(2)) - 0.1400000000e0 * m3 * lmx3 * cos(q(2)) * sin(q(3)) - 0.1400000000e0 * m3 * lmx3 * sin(q(2)) * cos(q(3)) + 0.1400000000e0 * m3 * lmz3 * cos(q(2)) * cos(q(3)) + 0.5040000000e-1 * m3 * sin(q(2)) + 0.1400000000e0 * m2 * sin(q(2)) * lmx2 + 0.1400000000e0 * m2 * cos(q(2)) * lmy2 - 0.6230000000e-1 * m3 * sin(q(2)) * sin(q(3)) + 0.6230000000e-1 * m3 * cos(q(2)) * cos(q(3)) - 0.1400000000e0 * m3 * lmz3 * sin(q(2)) * sin(q(3)) - 0.7200000000e0 * m3 * cos(q(2)) * lmx3 * sin(q(2)) * sin(q(3)) + 0.7200000000e0 * m3 * cos(q(2)) * lmz3 * sin(q(2)) * cos(q(3)) + 0.3204000000e0 * m3 * cos(q(2)) * sin(q(2)) * cos(q(3)) - 0.1296000000e0 * m2 * cos(q(2)) ^ 2 - 0.1e1 * I2y * cos(q(2)) ^ 2 - 0.1e1 * I3x * cos(q(3)) ^ 2 - 0.1e1 * I3x * cos(q(2)) ^ 2 + I3z * cos(q(2)) ^ 2 + I3z * cos(q(3)) ^ 2 - 0.3276250000e0 * m3 * cos(q(2)) ^ 2 - 0.1980250000e0 * m3 * cos(q(3)) ^ 2 + 0.3960500000e0 * m3 * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 + m2 * lmy2 ^ 2 * cos(q(2)) ^ 2 - 0.1e1 * m2 * cos(q(2)) ^ 2 * lmx2 ^ 2 - 0.7200000000e0 * m2 * cos(q(2)) ^ 2 * lmx2 - 0.2e1 * I3z * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 - 0.1e1 * m3 * lmz3 ^ 2 * cos(q(2)) ^ 2 - 0.1e1 * m3 * lmz3 ^ 2 * cos(q(3)) ^ 2 - 0.8900000000e0 * m3 * lmz3 * cos(q(2)) ^ 2 - 0.8900000000e0 * m3 * lmz3 * cos(q(3)) ^ 2 + m3 * lmx3 ^ 2 * cos(q(3)) ^ 2 + m3 * lmx3 ^ 2 * cos(q(2)) ^ 2 + 0.3204000000e0 * m3 * cos(q(2)) ^ 2 * sin(q(3)) - 0.2e1 * m3 * lmx3 ^ 2 * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 + 0.2e1 * m3 * lmz3 ^ 2 * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 + 0.1780000000e1 * m3 * lmz3 * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 + 0.7200000000e0 * m3 * lmx3 * cos(q(2)) ^ 2 * cos(q(3)) + 0.7200000000e0 * m3 * lmz3 * cos(q(2)) ^ 2 * sin(q(3)) - 0.4e1 * m3 * lmx3 * cos(q(2)) ^ 2 * cos(q(3)) * lmz3 * sin(q(3)) - 0.4e1 * m3 * lmx3 * cos(q(2)) * cos(q(3)) ^ 2 * lmz3 * sin(q(2)) - 0.1780000000e1 * m3 * lmx3 * cos(q(2)) ^ 2 * cos(q(3)) * sin(q(3)) - 0.1780000000e1 * m3 * lmx3 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) + 0.8900000000e0 * m3 * lmx3 * cos(q(3)) * sin(q(3)) + cos(q(2)) ^ 2 * I2x + I1y + I2y + 0.3325250000e0 * m3 + I3x - 0.7200000000e0 * m3 * lmx3 * cos(q(3)) - 0.7200000000e0 * m3 * lmz3 * sin(q(3)) - 0.3204000000e0 * m3 * sin(q(3));
M_12 = 0.4450000000e0 * m3 * lmy3 * cos(q(2)) * sin(q(3)) + 0.4450000000e0 * m3 * lmy3 * sin(q(2)) * cos(q(3)) + m3 * lmy3 * lmx3 * cos(q(2)) * cos(q(3)) - 0.1e1 * m3 * lmy3 * lmx3 * sin(q(2)) * sin(q(3)) + m3 * lmy3 * lmz3 * cos(q(2)) * sin(q(3)) + m3 * lmy3 * lmz3 * sin(q(2)) * cos(q(3)) - 0.3600000000e0 * m2 * lmz2 * cos(q(2)) + m2 * lmz2 * sin(q(2)) * lmy2 - 0.1e1 * m2 * lmz2 * cos(q(2)) * lmx2 - 0.3600000000e0 * m3 * lmy3 * cos(q(2));
M_13 = 0.5000000000e-2 * m3 * lmy3 * (0.200e3 * lmx3 * cos(q(2)) * cos(q(3)) - 0.200e3 * lmx3 * sin(q(2)) * sin(q(3)) + 0.200e3 * lmz3 * cos(q(2)) * sin(q(3)) + 0.200e3 * lmz3 * sin(q(2)) * cos(q(3)) + 0.89e2 * cos(q(2)) * sin(q(3)) + 0.89e2 * sin(q(2)) * cos(q(3)));
%M_21 = 0.4450000000e0 * m3 * lmy3 * cos(q(2)) * sin(q(3)) + 0.4450000000e0 * m3 * lmy3 * sin(q(2)) * cos(q(3)) + m3 * lmy3 * lmx3 * cos(q(2)) * cos(q(3)) - 0.1e1 * m3 * lmy3 * lmx3 * sin(q(2)) * sin(q(3)) + m3 * lmy3 * lmz3 * cos(q(2)) * sin(q(3)) + m3 * lmy3 * lmz3 * sin(q(2)) * cos(q(3)) - 0.3600000000e0 * m2 * lmz2 * cos(q(2)) + m2 * lmz2 * sin(q(2)) * lmy2 - 0.1e1 * m2 * lmz2 * cos(q(2)) * lmx2 - 0.3600000000e0 * m3 * lmy3 * cos(q(2));
M_22 =  m3 * lmx3 ^ 2 + 0.1296000000e0 * m2 + m3 * lmz3 ^ 2 + 0.8900000000e0 * m3 * lmz3 + m2 * lmy2 ^ 2 + m2 * lmx2 ^ 2 + 0.7200000000e0 * m2 * lmx2 + I2z + 0.3276250000e0 * m3 + I3y - 0.3204000000e0 * m3 * sin(q(3)) - 0.7200000000e0 * m3 * lmx3 * cos(q(3)) - 0.7200000000e0 * m3 * lmz3 * sin(q(3));
M_23 =  m3 * lmx3 ^ 2 + m3 * lmz3 ^ 2 + 0.8900000000e0 * m3 * lmz3 + 0.1980250000e0 * m3 + I3y - 0.1602000000e0 * m3 * sin(q(3)) - 0.3600000000e0 * m3 * lmx3 * cos(q(3)) - 0.3600000000e0 * m3 * lmz3 * sin(q(3));  
%M_31 = 0.5000000000e-2 * m3 * lmy3 * (0.200e3 * lmx3 * cos(q(2)) * cos(q(3)) - 0.200e3 * lmx3 * sin(q(2)) * sin(q(3)) + 0.200e3 * lmz3 * cos(q(2)) * sin(q(3)) + 0.200e3 * lmz3 * sin(q(2)) * cos(q(3)) + 0.89e2 * cos(q(2)) * sin(q(3)) + 0.89e2 * sin(q(2)) * cos(q(3)));
%M_32 =  m3 * lmx3 ^ 2 + m3 * lmz3 ^ 2 + 0.8900000000e0 * m3 * lmz3 + 0.1980250000e0 * m3 + I3y - 0.1602000000e0 * m3 * sin(q(3)) - 0.3600000000e0 * m3 * lmx3 * cos(q(3)) - 0.3600000000e0 * m3 * lmz3 * sin(q(3));
M_33 = m3 * lmx3 ^ 2 + m3 * lmz3 ^ 2 + 0.8900000000e0 * m3 * lmz3 + 0.1980250000e0 * m3 + I3y;



M_11_est = RBFNN_M_11.Calculate([q(2) q(3)]);
M_12_est = RBFNN_M_12.Calculate([q(2) q(3)]);
M_13_est = RBFNN_M_13.Calculate([q(2) q(3)]);
M_22_est = RBFNN_M_22.Calculate(q(3));
M_23_est = RBFNN_M_23.Calculate(q(3));
M_33_est = RBFNN_M_33.Calculate(1);


M_11_err = M_11 - M_11_est;
M_12_err = M_12 - M_12_est;
M_13_err = M_13 - M_13_est;
M_22_err = M_22 - M_22_est;
M_23_err = M_23 - M_23_est;
M_33_err = M_33 - M_33_est;


DATA_M = [DATA_M, [M_11_err; M_12_err; M_13_err; M_22_err; M_23_err; M_33_err]];

RBFNN_M_11 = RBFNN_M_11.Train([q(2) q(3)], M_11_err);
RBFNN_M_12 = RBFNN_M_12.Train([q(2) q(3)], M_12_err);
RBFNN_M_13 = RBFNN_M_13.Train([q(2) q(3)], M_13_err);
RBFNN_M_22 = RBFNN_M_22.Train(q(3), M_22_err);
RBFNN_M_23 = RBFNN_M_23.Train(q(3), M_23_err);
RBFNN_M_33 = RBFNN_M_33.Train(1, M_33_err);

%disp(['in M.m, done with training']);

[M_11_est outp_M_11] = RBFNN_M_11.Calculate([q(2) q(3)]);
[M_12_est outp_M_12]= RBFNN_M_12.Calculate([q(2) q(3)]);
[M_13_est outp_M_13]= RBFNN_M_13.Calculate([q(2) q(3)]);
M_21_est = M_12_est;
[M_22_est outp_M_22]= RBFNN_M_22.Calculate(q(3));
[M_23_est outp_M_23]= RBFNN_M_23.Calculate(q(3));
M_31_est = M_13_est;
M_32_est = M_23_est;
[M_33_est outp_M_33]= RBFNN_M_33.Calculate(1);


act_outp_M_11 = act_outp_M_11 + outp_M_11;
act_outp_M_12 = act_outp_M_12 + outp_M_12;
act_outp_M_13 = act_outp_M_13 + outp_M_13;
act_outp_M_22 = act_outp_M_22 + outp_M_22;
act_outp_M_23 = act_outp_M_23 + outp_M_23;
act_outp_M_33 = act_outp_M_33 + outp_M_33;

if length(M_11_prun(1,:)) == 1
    M_prun_1 = 2;
else
    M_prun_1 = length(M_11_prun(1,:)) + 1;%simulation iteration number
end

len = length(DATA_M);
%change here for the different pruning methods
%weight pruning from 2200-6600, node from 4400-8800(not necessary to end
%this
if len > 2200 && len < 6600
    d1 = DATA_M(1, len-400:len);
    d2 = DATA_M(2, len-400:len);
    d3 = DATA_M(3, len-400:len);
    d4 = DATA_M(4, len-400:len);
    d5 = DATA_M(5, len-400:len);
    d6 = DATA_M(6, len-400:len);
    rms_M11 = Rmse(d1);
    rms_M12 = Rmse(d2);
    rms_M13 = Rmse(d3);
    rms_M22 = Rmse(d4);
    rms_M23 = Rmse(d5);
    rms_M33 = Rmse(d6);
    
    if rms_M11 < 0.01
        %prune by node output
        [RBFNN_M_11 act_outp_M_11 prunedO p_thO] = RBFNN_M_11.pruneO(act_outp_M_11, outp_th_M, 2);
        %prune by weight magnitude
        [RBFNN_M_11 n_prunM11 prunedW p_thW act_outp_M_11] = RBFNN_M_11.pruneW(weight_th_M, 2, n_prunW_M(1,1), act_outp_M_11);
        %disp(['after pruning RBFNN_M_11 has ' num2str(length(RBFNN_M_11.mu)) ' units']);
        n_prunW_M(1,1) = n_prunM11;
       
       %store the pruning result     
        M_11_prun_2 =  p_thW;
        if prunedO == 0
            M_11_prun_3 = 0; 
        else
            M_11_prun_3 = length(prunedW);
        end
        M_11_prun_4 =  p_thO;
        if prunedO == 0
            M_11_prun_5 = 0; 
        else
            M_11_prun_5 = length(prunedO);
        end        
        M_11_prun = [M_11_prun, [M_prun_1; M_11_prun_2; M_11_prun_3; M_11_prun_4; M_11_prun_5]];
        
    else%if the error is not small enough
        M_11_prun_2 = 0;
        M_11_prun_3 = 0;
        M_11_prun_4 = 0;
        M_11_prun_5 = 0;        
        M_11_prun = [M_11_prun, [M_prun_1; M_11_prun_2; M_11_prun_3; M_11_prun_4; M_11_prun_5]];
    end
    
    
    if rms_M12 < 0.01
        %prune by node output
        [RBFNN_M_12 act_outp_M_12 prunedO p_thO] = RBFNN_M_12.pruneO(act_outp_M_12, outp_th_M, 2);
        %prune by weight magnitude
        [RBFNN_M_12 n_prunM12 prunedW p_thW act_outp_M_12] = RBFNN_M_12.pruneW(weight_th_M, 2, n_prunW_M(2,1), act_outp_M_12);
        %disp(['pruned RBFNN_M_12, units are ' num2str(length(RBFNN_M_12.mu))]);
        n_prunW_M(2,1) = n_prunM12;
        
        %store the pruning result
        M_12_prun_2 =  p_thW;
        if prunedW == 0 
            M_12_prun_3 = 0; 
        else
            M_12_prun_3 = length(prunedW);
        end      
        M_12_prun_4 =  p_thO;
        if prunedO == 0 
            M_12_prun_5 = 0; 
        else
            M_12_prun_5 = length(prunedO);
        end
        M_12_prun = [M_12_prun, [M_prun_1; M_12_prun_2; M_12_prun_3; M_12_prun_4; M_12_prun_5]];  
        
    else%if the error is not small enough
        M_12_prun_2 = 0;
        M_12_prun_3 = 0;
        M_12_prun_4 = 0;
        M_12_prun_5 = 0;       
        M_12_prun = [M_12_prun, [M_prun_1; M_12_prun_2; M_12_prun_3; M_12_prun_4; M_12_prun_5]];        
    end
    
    if rms_M13 < 0.01
        %prune by node output
        [RBFNN_M_13 act_outp_M_13 prunedO p_thO] = RBFNN_M_13.pruneO(act_outp_M_13, outp_th_M, 2);
        %prune by weight magnitude
        [RBFNN_M_13 n_prunM13 prunedW p_thW act_outp_M_13] = RBFNN_M_13.pruneW(weight_th_M, 2, n_prunW_M(3,1), act_outp_M_13);
        %disp(['pruned RBFNN_M_13, units are ' num2str(length(RBFNN_M_13.mu))]);
        n_prunW_M(3,1) = n_prunM13;
        
        %store the pruning result
        M_13_prun_2 =  p_thW;
        if prunedW == 0 
            M_13_prun_3 = 0; 
        else
            M_13_prun_3 = length(prunedW);
        end
        M_13_prun_4 =  p_thO;
        if prunedO == 0 
            M_13_prun_5 = 0; 
        else
            M_13_prun_5 = length(prunedO);
        end        
        M_13_prun = [M_13_prun, [M_prun_1; M_13_prun_2; M_13_prun_3; M_13_prun_4; M_13_prun_5]];  
        
    else%if the error is not small enough
        M_13_prun_2 = 0;
        M_13_prun_3 = 0;
        M_13_prun_4 = 0;
        M_13_prun_5 = 0;       
        M_13_prun = [M_13_prun, [M_prun_1; M_13_prun_2; M_13_prun_3; M_13_prun_4; M_13_prun_5]];        
    end
    
   
    if rms_M22 < 0.01
        %prune by node output
        [RBFNN_M_22 act_outp_M_22 prunedO p_thO] = RBFNN_M_22.pruneO(act_outp_M_22, outp_th_M, 1);
        %prune by weight magnitude
        [RBFNN_M_22 n_prunM22 prunedW p_thW act_outp_M_22]= RBFNN_M_22.pruneW(weight_th_M, 1, n_prunW_M(4,1), act_outp_M_22);
        %disp(['pruned RBFNN_M_22, units are ' num2str(length(RBFNN_M_22.mu))]);
        n_prunW_M(4,1) = n_prunM22;
        
        %store the pruning result
        M_22_prun_2 =  p_thW;
        if prunedO == 0
            M_22_prun_3 = 0; 
        else
            M_22_prun_3 = length(prunedW);
        end
        M_22_prun_4 =  p_thO;
        if prunedO == 0
            M_22_prun_5 = 0; 
        else
            M_22_prun_5 = length(prunedO);
        end       
        M_22_prun = [M_22_prun, [M_prun_1; M_22_prun_2; M_22_prun_3; M_22_prun_4; M_22_prun_5]];
        
    else%if the error is not small enough
        M_22_prun_2 = 0;
        M_22_prun_3 = 0;
        M_22_prun_4 = 0;
        M_22_prun_5 = 0;
        M_22_prun = [M_22_prun, [M_prun_1; M_22_prun_2; M_22_prun_3; M_22_prun_4; M_22_prun_5]];
    end
    
    if rms_M23 < 0.01
        %prune by node output
        [RBFNN_M_23 act_outp_M_23 prunedO p_thO] = RBFNN_M_23.pruneO(act_outp_M_23, outp_th_M, 1);
        %prune by weight magnitude
        [RBFNN_M_23 n_prunM23 prunedW p_thW act_outp_M_23]= RBFNN_M_23.pruneW(weight_th_M, 1, n_prunW_M(5,1), act_outp_M_23);
        %disp(['pruned RBFNN_M_23, units are ' num2str(length(RBFNN_M_23.mu))]);
        n_prunW_M(5,1) = n_prunM23;
        
        %store the pruning result
        M_23_prun_2 =  p_thW;
        if prunedO == 0
            M_23_prun_3 = 0; 
        else
            M_23_prun_3 = length(prunedW);
        end
        M_23_prun_4 =  p_thO;
        if prunedO == 0
            M_23_prun_5 = 0; 
        else
            M_23_prun_5 = length(prunedO);
        end       
        M_23_prun = [M_23_prun, [M_prun_1; M_23_prun_2; M_23_prun_3; M_23_prun_4; M_23_prun_5]];
        
    else%if the error is not small enough
        M_23_prun_2 = 0;
        M_23_prun_3 = 0;
        M_23_prun_4 = 0;
        M_23_prun_5 = 0;
        M_23_prun = [M_23_prun, [M_prun_1; M_23_prun_2; M_23_prun_3; M_23_prun_4; M_23_prun_5]];
    end
    
    if rms_M33 < 0.01
        %prune by node output
        [RBFNN_M_33 act_outp_M_33 prunedO p_thO] = RBFNN_M_33.pruneO(act_outp_M_33, outp_th_M, 1);
        %prune by weight magnitude
        [RBFNN_M_33 n_prunM33 prunedW p_thW act_outp_M_33]= RBFNN_M_33.pruneW(weight_th_M, 1, n_prunW_M(6,1), act_outp_M_33);
        %disp(['pruned RBFNN_M_33, units are ' num2str(length(RBFNN_M_33.mu))]);
        n_prunW_M(6,1) = n_prunM33;
        display =1;
        
        %store the pruning result
        M_33_prun_2 =  p_thW;
        if prunedO == 0
            M_33_prun_3 = 0; 
        else
            M_33_prun_3 = length(prunedW);
        end
        M_33_prun_4 =  p_thO;
        if prunedO == 0
            M_33_prun_5 = 0; 
        else
            M_33_prun_5 = length(prunedO);
        end       
        M_33_prun = [M_33_prun, [M_prun_1; M_33_prun_2; M_33_prun_3; M_33_prun_4; M_33_prun_5]];
        
    else%if the error is not small enough
        M_33_prun_2 = 0;
        M_33_prun_3 = 0;
        M_33_prun_4 = 0;
        M_33_prun_5 = 0;
        M_33_prun = [M_33_prun, [M_prun_1; M_33_prun_2; M_33_prun_3; M_33_prun_4; M_33_prun_5]];
    end
    
else%not done enough iterations to prune  
    M_11_prun_2 = 0;
    M_11_prun_3 = 0;
    M_11_prun_4 = 0;
    M_11_prun_5 = 0;        
    M_11_prun = [M_11_prun, [M_prun_1; M_11_prun_2; M_11_prun_3; M_11_prun_4; M_11_prun_5]];

    M_12_prun_2 = 0;
    M_12_prun_3 = 0;
    M_12_prun_4 = 0;
    M_12_prun_5 = 0;       
    M_12_prun = [M_12_prun, [M_prun_1; M_12_prun_2; M_12_prun_3; M_12_prun_4; M_12_prun_5]];  
        
    M_13_prun_2 = 0;
    M_13_prun_3 = 0;
    M_13_prun_4 = 0;
    M_13_prun_5 = 0;       
    M_13_prun = [M_13_prun, [M_prun_1; M_13_prun_2; M_13_prun_3; M_13_prun_4; M_13_prun_5]];
    
    M_22_prun_2 = 0;
    M_22_prun_3 = 0;
    M_22_prun_4 = 0;
    M_22_prun_5 = 0;
    M_22_prun = [M_22_prun, [M_prun_1; M_22_prun_2; M_22_prun_3; M_22_prun_4; M_22_prun_5]];    
    
    M_23_prun_2 = 0;
    M_23_prun_3 = 0;
    M_23_prun_4 = 0;
    M_23_prun_5 = 0;
    M_23_prun = [M_23_prun, [M_prun_1; M_23_prun_2; M_23_prun_3; M_23_prun_4; M_23_prun_5]];
    
    M_33_prun_2 = 0;
    M_33_prun_3 = 0;
    M_33_prun_4 = 0;
    M_33_prun_5 = 0;
    M_33_prun = [M_33_prun, [M_prun_1; M_33_prun_2; M_33_prun_3; M_33_prun_4; M_33_prun_5]]; 
    
end


M = [M_11_est M_12_est M_13_est; M_21_est M_22_est M_23_est; M_31_est M_32_est M_33_est;];


nM_11 = norm(RBFNN_M_11.w,2);
nM_12 = norm(RBFNN_M_12.w,2);
nM_13 = norm(RBFNN_M_13.w,2);
nM_22 = norm(RBFNN_M_22.w,2);
nM_23 = norm(RBFNN_M_23.w,2);
nM_33 = norm(RBFNN_M_33.w,2);

norm_M = [norm_M, [nM_11; nM_12; nM_13; nM_22; nM_23; nM_33;]];


end