function Out = Tau(u)
%finds the control torque from the inverse kinematic controller. Choose
%between using the manipulator model and RBF networks

global Kp;
global Kd;

%desired trajectory
qd = u(1:3);
dqd = u(4:6);
ddqd = u(7:9);

q = u(10:12);
dq = u(13:15);

%Estimations by RBF networks
Mt = M_hat(q);
Ct = C_hat(q,dq);
Gt = G_hat(q);

%Model of manipulator
%Mt = M(q);
%Ct = C(q,dq);
%Gt = G(q);

aq = ddqd + (Kd*(dqd - dq) + Kp*(qd - q));
Out = Mt*aq + Ct*dq + Gt;


end