%from Stepan Pchelkin

function C = C(q,dq)
%returns the C matrix from the manipulator model. 

global m2 m3;
global lmx2 lmy2 lmz2;
global lmx3 lmy3 lmz3;
global I2x I2y;
global I3x I3z;


C = [-0.1e1 * dq(2) * m3 * lmx3 * lmz3 - 0.7000000000e-1 * dq(3) * m3 * lmz3 * sin(q(2)) * cos(q(3)) - 0.7000000000e-1 * dq(3) * m3 * lmz3 * cos(q(2)) * sin(q(3)) - 0.3960500000e0 * dq(3) * m3 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) + 0.2e1 * dq(3) * I3z * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.1602000000e0 * dq(3) * m3 * cos(q(2)) * sin(q(3)) * sin(q(2)) - 0.3960500000e0 * dq(3) * m3 * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.2e1 * dq(3) * I3x * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) + 0.2e1 * dq(3) * I3z * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.3600000000e0 * dq(3) * m3 * cos(q(2)) ^ 2 * lmx3 * sin(q(3)) + 0.3600000000e0 * dq(3) * m3 * cos(q(2)) ^ 2 * lmz3 * cos(q(3)) - 0.1780000000e1 * dq(3) * m3 * lmx3 * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 + 0.2e1 * dq(3) * m3 * lmx3 * cos(q(3)) ^ 2 * lmz3 + dq(3) * m3 * lmz3 ^ 2 * cos(q(3)) * sin(q(3)) + 0.8900000000e0 * dq(3) * m3 * lmz3 * cos(q(3)) * sin(q(3)) - 0.1e1 * dq(3) * m3 * lmx3 ^ 2 * cos(q(3)) * sin(q(3)) - 0.4450000000e0 * dq(2) * m3 * lmx3 - 0.1e1 * dq(3) * m3 * lmx3 ^ 2 * cos(q(2)) * sin(q(2)) + dq(3) * m3 * lmz3 ^ 2 * cos(q(2)) * sin(q(2)) + 0.8900000000e0 * dq(3) * m3 * lmz3 * cos(q(2)) * sin(q(2)) - 0.2e1 * dq(2) * m3 * lmz3 ^ 2 * cos(q(2)) ^ 2 * cos(q(3)) * sin(q(3)) - 0.1780000000e1 * dq(2) * m3 * lmz3 * cos(q(2)) ^ 2 * cos(q(3)) * sin(q(3)) + 0.2e1 * dq(2) * m3 * lmx3 ^ 2 * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.4e1 * dq(2) * m3 * lmx3 * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 * lmz3 + 0.2e1 * dq(2) * m3 * lmx3 ^ 2 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.2e1 * dq(2) * m3 * lmz3 ^ 2 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.1780000000e1 * dq(2) * m3 * lmz3 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.7200000000e0 * dq(2) * m3 * lmx3 * cos(q(2)) * cos(q(3)) * sin(q(2)) - 0.7200000000e0 * dq(2) * m3 * lmz3 * cos(q(2)) * sin(q(3)) * sin(q(2)) - 0.2e1 * dq(3) * m3 * lmz3 ^ 2 * cos(q(2)) ^ 2 * cos(q(3)) * sin(q(3)) - 0.1780000000e1 * dq(3) * m3 * lmz3 * cos(q(2)) ^ 2 * cos(q(3)) * sin(q(3)) + 0.2e1 * dq(3) * m3 * lmx3 ^ 2 * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.4e1 * dq(3) * m3 * lmx3 * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 * lmz3 + 0.2e1 * dq(3) * m3 * lmx3 ^ 2 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.2e1 * dq(3) * m3 * lmz3 ^ 2 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.1780000000e1 * dq(3) * m3 * lmz3 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.3600000000e0 * dq(3) * m3 * lmx3 * cos(q(2)) * cos(q(3)) * sin(q(2)) - 0.3600000000e0 * dq(3) * m3 * lmz3 * cos(q(2)) * sin(q(3)) * sin(q(2)) - 0.3600000000e0 * dq(3) * m3 * lmz3 * cos(q(3)) + 0.3600000000e0 * dq(3) * m3 * lmx3 * sin(q(3)) + 0.3204000000e0 * dq(2) * m3 * cos(q(2)) ^ 2 * cos(q(3)) - 0.3115000000e-1 * dq(2) * m3 * cos(q(2)) * sin(q(3)) - 0.3115000000e-1 * dq(2) * m3 * sin(q(2)) * cos(q(3)) + 0.8900000000e0 * dq(2) * m3 * lmx3 * cos(q(2)) ^ 2 + 0.7200000000e0 * dq(2) * m2 * cos(q(2)) ^ 2 * lmy2 + dq(2) * I3x * cos(q(2)) * sin(q(2)) + 0.7000000000e-1 * dq(2) * m2 * cos(q(2)) * lmx2 - 0.7000000000e-1 * dq(2) * m2 * sin(q(2)) * lmy2 + 0.3276250000e0 * dq(2) * m3 * cos(q(2)) * sin(q(2)) - 0.1e1 * dq(2) * cos(q(2)) * I2x * sin(q(2)) - 0.1e1 * dq(2) * I3z * cos(q(2)) * sin(q(2)) + 0.1296000000e0 * dq(2) * m2 * cos(q(2)) * sin(q(2)) + dq(2) * I2y * cos(q(2)) * sin(q(2)) + 0.1602000000e0 * dq(3) * m3 * cos(q(2)) ^ 2 * cos(q(3)) - 0.3115000000e-1 * dq(3) * m3 * cos(q(2)) * sin(q(3)) - 0.3115000000e-1 * dq(3) * m3 * sin(q(2)) * cos(q(3)) + dq(3) * I3x * cos(q(3)) * sin(q(3)) - 0.1e1 * dq(3) * I3z * cos(q(3)) * sin(q(3)) + 0.1980250000e0 * dq(3) * m3 * cos(q(3)) * sin(q(3)) + 0.8900000000e0 * dq(3) * m3 * lmx3 * cos(q(3)) ^ 2 + 0.4e1 * dq(2) * m3 * lmx3 * cos(q(2)) * cos(q(3)) * lmz3 * sin(q(3)) * sin(q(2)) + 0.4e1 * dq(3) * m3 * lmx3 * cos(q(2)) * cos(q(3)) * lmz3 * sin(q(3)) * sin(q(2)) + 0.1780000000e1 * dq(2) * m3 * lmx3 * cos(q(2)) * cos(q(3)) * sin(q(3)) * sin(q(2)) + 0.1780000000e1 * dq(3) * m3 * lmx3 * cos(q(2)) * cos(q(3)) * sin(q(3)) * sin(q(2)) - 0.1e1 * dq(3) * m3 * lmx3 * lmz3 + 0.2520000000e-1 * dq(2) * m2 * cos(q(2)) + 0.2520000000e-1 * dq(2) * m3 * cos(q(2)) - 0.1602000000e0 * dq(3) * m3 * cos(q(3)) + 0.2e1 * dq(2) * m3 * lmx3 * cos(q(3)) ^ 2 * lmz3 + 0.2e1 * dq(3) * m3 * lmx3 * cos(q(2)) ^ 2 * lmz3 + 0.8900000000e0 * dq(2) * m3 * lmx3 * cos(q(3)) ^ 2 + dq(2) * I3x * sin(q(3)) * cos(q(3)) - 0.1e1 * dq(2) * I3z * sin(q(3)) * cos(q(3)) + 0.3600000000e0 * dq(2) * m3 * lmx3 * sin(q(3)) - 0.3600000000e0 * dq(2) * m3 * lmz3 * cos(q(3)) + dq(2) * m3 * lmz3 ^ 2 * cos(q(3)) * sin(q(3)) + 0.8900000000e0 * dq(2) * m3 * lmz3 * cos(q(3)) * sin(q(3)) - 0.1e1 * dq(2) * m3 * lmx3 ^ 2 * sin(q(3)) * cos(q(3)) - 0.1602000000e0 * dq(2) * m3 * cos(q(3)) + 0.8900000000e0 * dq(3) * m3 * lmx3 * cos(q(2)) ^ 2 + 0.1980250000e0 * dq(3) * m3 * cos(q(2)) * sin(q(2)) - 0.1e1 * dq(3) * I3z * cos(q(2)) * sin(q(2)) + dq(3) * I3x * cos(q(2)) * sin(q(2)) - 0.4450000000e0 * dq(3) * m3 * lmx3 + 0.2e1 * dq(2) * m3 * lmx3 * cos(q(2)) ^ 2 * lmz3 + 0.2e1 * dq(2) * m2 * cos(q(2)) ^ 2 * lmx2 * lmy2 - 0.2e1 * dq(2) * I3x * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) + 0.7000000000e-1 * dq(2) * m3 * lmx3 * sin(q(2)) * sin(q(3)) - 0.7000000000e-1 * dq(2) * m3 * lmx3 * cos(q(2)) * cos(q(3)) - 0.7000000000e-1 * dq(2) * m3 * lmz3 * sin(q(2)) * cos(q(3)) - 0.7000000000e-1 * dq(2) * m3 * lmz3 * cos(q(2)) * sin(q(3)) - 0.3960500000e0 * dq(2) * m3 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) + 0.2e1 * dq(2) * I3z * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.3204000000e0 * dq(2) * m3 * cos(q(2)) * sin(q(3)) * sin(q(2)) - 0.3960500000e0 * dq(2) * m3 * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.2e1 * dq(2) * I3x * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) + 0.2e1 * dq(2) * I3z * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.7200000000e0 * dq(2) * m3 * cos(q(2)) ^ 2 * lmx3 * sin(q(3)) + 0.7200000000e0 * dq(2) * m3 * cos(q(2)) ^ 2 * lmz3 * cos(q(3)) - 0.1780000000e1 * dq(2) * m3 * lmx3 * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 - 0.1e1 * dq(2) * m2 * lmy2 ^ 2 * cos(q(2)) * sin(q(2)) + dq(2) * m2 * cos(q(2)) * lmx2 ^ 2 * sin(q(2)) + 0.7200000000e0 * dq(2) * m2 * cos(q(2)) * lmx2 * sin(q(2)) + dq(2) * m3 * lmz3 ^ 2 * cos(q(2)) * sin(q(2)) + 0.8900000000e0 * dq(2) * m3 * lmz3 * cos(q(2)) * sin(q(2)) - 0.1e1 * dq(2) * m3 * lmx3 ^ 2 * cos(q(2)) * sin(q(2)) - 0.2e1 * dq(3) * I3x * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) + 0.7000000000e-1 * dq(3) * m3 * lmx3 * sin(q(2)) * sin(q(3)) - 0.7000000000e-1 * dq(3) * m3 * lmx3 * cos(q(2)) * cos(q(3)) - 0.3600000000e0 * dq(2) * m2 * lmy2 + 0.1980250000e0 * dq(2) * m3 * sin(q(3)) * cos(q(3)) - 0.1e1 * dq(2) * m2 * lmx2 * lmy2 -0.1602000000e0 * dq(1) * m3 * cos(q(3)) - 0.2e1 * dq(1) * m3 * lmz3 ^ 2 * cos(q(2)) ^ 2 * cos(q(3)) * sin(q(3)) - 0.1780000000e1 * dq(1) * m3 * lmz3 * cos(q(2)) ^ 2 * cos(q(3)) * sin(q(3)) + 0.2e1 * dq(1) * m3 * lmx3 ^ 2 * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.4e1 * dq(1) * m3 * lmx3 * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 * lmz3 + 0.2e1 * dq(1) * m3 * lmx3 ^ 2 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.2e1 * dq(1) * m3 * lmz3 ^ 2 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.1780000000e1 * dq(1) * m3 * lmz3 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.7200000000e0 * dq(1) * m3 * lmx3 * cos(q(2)) * cos(q(3)) * sin(q(2)) - 0.7200000000e0 * dq(1) * m3 * lmz3 * cos(q(2)) * sin(q(3)) * sin(q(2)) - 0.1e1 * dq(2) * m3 * lmy3 * lmx3 * sin(q(2)) * cos(q(3)) - 0.1e1 * dq(2) * m3 * lmy3 * lmx3 * cos(q(2)) * sin(q(3)) - 0.1e1 * dq(2) * m3 * lmy3 * lmz3 * sin(q(2)) * sin(q(3)) + dq(2) * m3 * lmy3 * lmz3 * cos(q(2)) * cos(q(3)) - 0.1e1 * m3 * lmy3 * dq(3) * lmx3 * sin(q(2)) * cos(q(3)) - 0.1e1 * m3 * lmy3 * dq(3) * lmx3 * cos(q(2)) * sin(q(3)) - 0.1e1 * m3 * lmy3 * dq(3) * lmz3 * sin(q(2)) * sin(q(3)) + m3 * lmy3 * dq(3) * lmz3 * cos(q(2)) * cos(q(3)) - 0.3960500000e0 * dq(1) * m3 * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.2e1 * dq(1) * I3x * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) + 0.2e1 * dq(1) * I3z * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.7200000000e0 * dq(1) * m3 * cos(q(2)) ^ 2 * lmx3 * sin(q(3)) + 0.7200000000e0 * dq(1) * m3 * cos(q(2)) ^ 2 * lmz3 * cos(q(3)) - 0.1780000000e1 * dq(1) * m3 * lmx3 * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 + 0.2e1 * dq(1) * m3 * lmx3 * cos(q(3)) ^ 2 * lmz3 + dq(1) * m3 * lmz3 ^ 2 * cos(q(3)) * sin(q(3)) + 0.8900000000e0 * dq(1) * m3 * lmz3 * cos(q(3)) * sin(q(3)) - 0.1e1 * dq(1) * m3 * lmx3 ^ 2 * cos(q(3)) * sin(q(3)) - 0.4450000000e0 * dq(2) * m3 * lmy3 * sin(q(2)) * sin(q(3)) + 0.4450000000e0 * dq(2) * m3 * lmy3 * cos(q(2)) * cos(q(3)) - 0.4450000000e0 * m3 * lmy3 * dq(3) * sin(q(2)) * sin(q(3)) + 0.4450000000e0 * m3 * lmy3 * dq(3) * cos(q(2)) * cos(q(3)) - 0.2e1 * dq(1) * I3x * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) + 0.7000000000e-1 * dq(1) * m3 * lmx3 * sin(q(2)) * sin(q(3)) - 0.7000000000e-1 * dq(1) * m3 * lmx3 * cos(q(2)) * cos(q(3)) - 0.7000000000e-1 * dq(1) * m3 * lmz3 * sin(q(2)) * cos(q(3)) - 0.7000000000e-1 * dq(1) * m3 * lmz3 * cos(q(2)) * sin(q(3)) - 0.3960500000e0 * dq(1) * m3 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) + 0.2e1 * dq(1) * I3z * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.3204000000e0 * dq(1) * m3 * cos(q(2)) * sin(q(3)) * sin(q(2)) + 0.4e1 * dq(1) * m3 * lmx3 * cos(q(2)) * cos(q(3)) * lmz3 * sin(q(3)) * sin(q(2)) + 0.7200000000e0 * dq(1) * m2 * cos(q(2)) ^ 2 * lmy2 + 0.7000000000e-1 * dq(1) * m2 * cos(q(2)) * lmx2 - 0.7000000000e-1 * dq(1) * m2 * sin(q(2)) * lmy2 - 0.1e1 * dq(1) * cos(q(2)) * I2x * sin(q(2)) + 0.1296000000e0 * dq(1) * m2 * cos(q(2)) * sin(q(2)) + dq(1) * I2y * cos(q(2)) * sin(q(2)) + 0.3600000000e0 * dq(2) * m2 * lmz2 * sin(q(2)) + 0.3600000000e0 * dq(2) * m3 * lmy3 * sin(q(2)) + 0.2e1 * dq(1) * m3 * lmx3 * cos(q(2)) ^ 2 * lmz3 + 0.3204000000e0 * dq(1) * m3 * cos(q(2)) ^ 2 * cos(q(3)) - 0.3115000000e-1 * dq(1) * m3 * cos(q(2)) * sin(q(3)) - 0.3115000000e-1 * dq(1) * m3 * sin(q(2)) * cos(q(3)) + dq(1) * I3x * cos(q(3)) * sin(q(3)) - 0.1e1 * dq(1) * I3z * cos(q(3)) * sin(q(3)) + 0.1980250000e0 * dq(1) * m3 * cos(q(3)) * sin(q(3)) + 0.8900000000e0 * dq(1) * m3 * lmx3 * cos(q(3)) ^ 2 - 0.3600000000e0 * dq(1) * m3 * lmz3 * cos(q(3)) + 0.3600000000e0 * dq(1) * m3 * lmx3 * sin(q(3)) - 0.3600000000e0 * dq(1) * m2 * lmy2 + dq(1) * m3 * lmz3 ^ 2 * cos(q(2)) * sin(q(2)) + 0.8900000000e0 * dq(1) * m3 * lmz3 * cos(q(2)) * sin(q(2)) - 0.1e1 * dq(1) * m2 * lmx2 * lmy2 + 0.2520000000e-1 * dq(1) * m2 * cos(q(2)) + 0.2520000000e-1 * dq(1) * m3 * cos(q(2)) - 0.1e1 * dq(1) * m3 * lmx3 * lmz3 + 0.2e1 * dq(1) * m2 * cos(q(2)) ^ 2 * lmx2 * lmy2 - 0.1e1 * dq(1) * m2 * lmy2 ^ 2 * cos(q(2)) * sin(q(2)) + dq(1) * m2 * cos(q(2)) * lmx2 ^ 2 * sin(q(2)) + 0.7200000000e0 * dq(1) * m2 * cos(q(2)) * lmx2 * sin(q(2)) + dq(2) * m2 * lmz2 * cos(q(2)) * lmy2 + dq(2) * m2 * lmz2 * sin(q(2)) * lmx2 + 0.1780000000e1 * dq(1) * m3 * lmx3 * cos(q(2)) * cos(q(3)) * sin(q(3)) * sin(q(2)) - 0.1e1 * dq(1) * m3 * lmx3 ^ 2 * cos(q(2)) * sin(q(2)) - 0.4450000000e0 * dq(1) * m3 * lmx3 + 0.3276250000e0 * dq(1) * m3 * cos(q(2)) * sin(q(2)) + dq(1) * I3x * cos(q(2)) * sin(q(2)) - 0.1e1 * dq(1) * I3z * cos(q(2)) * sin(q(2)) + 0.8900000000e0 * dq(1) * m3 * lmx3 * cos(q(2)) ^ 2 -0.1602000000e0 * dq(1) * m3 * cos(q(3)) - 0.2e1 * dq(1) * m3 * lmz3 ^ 2 * cos(q(2)) ^ 2 * cos(q(3)) * sin(q(3)) - 0.1780000000e1 * dq(1) * m3 * lmz3 * cos(q(2)) ^ 2 * cos(q(3)) * sin(q(3)) + 0.2e1 * dq(1) * m3 * lmx3 ^ 2 * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.4e1 * dq(1) * m3 * lmx3 * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 * lmz3 + 0.2e1 * dq(1) * m3 * lmx3 ^ 2 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.2e1 * dq(1) * m3 * lmz3 ^ 2 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.1780000000e1 * dq(1) * m3 * lmz3 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.3600000000e0 * dq(1) * m3 * lmx3 * cos(q(2)) * cos(q(3)) * sin(q(2)) - 0.3600000000e0 * dq(1) * m3 * lmz3 * cos(q(2)) * sin(q(3)) * sin(q(2)) - 0.1e1 * dq(2) * m3 * lmy3 * lmx3 * sin(q(2)) * cos(q(3)) - 0.1e1 * dq(2) * m3 * lmy3 * lmx3 * cos(q(2)) * sin(q(3)) - 0.1e1 * dq(2) * m3 * lmy3 * lmz3 * sin(q(2)) * sin(q(3)) + dq(2) * m3 * lmy3 * lmz3 * cos(q(2)) * cos(q(3)) - 0.1e1 * m3 * lmy3 * dq(3) * lmx3 * sin(q(2)) * cos(q(3)) - 0.1e1 * m3 * lmy3 * dq(3) * lmx3 * cos(q(2)) * sin(q(3)) - 0.1e1 * m3 * lmy3 * dq(3) * lmz3 * sin(q(2)) * sin(q(3)) + m3 * lmy3 * dq(3) * lmz3 * cos(q(2)) * cos(q(3)) - 0.3960500000e0 * dq(1) * m3 * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.2e1 * dq(1) * I3x * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) + 0.2e1 * dq(1) * I3z * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.3600000000e0 * dq(1) * m3 * cos(q(2)) ^ 2 * lmx3 * sin(q(3)) + 0.3600000000e0 * dq(1) * m3 * cos(q(2)) ^ 2 * lmz3 * cos(q(3)) - 0.1780000000e1 * dq(1) * m3 * lmx3 * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 + 0.2e1 * dq(1) * m3 * lmx3 * cos(q(3)) ^ 2 * lmz3 + dq(1) * m3 * lmz3 ^ 2 * cos(q(3)) * sin(q(3)) + 0.8900000000e0 * dq(1) * m3 * lmz3 * cos(q(3)) * sin(q(3)) - 0.1e1 * dq(1) * m3 * lmx3 ^ 2 * cos(q(3)) * sin(q(3)) - 0.4450000000e0 * dq(2) * m3 * lmy3 * sin(q(2)) * sin(q(3)) + 0.4450000000e0 * dq(2) * m3 * lmy3 * cos(q(2)) * cos(q(3)) - 0.4450000000e0 * m3 * lmy3 * dq(3) * sin(q(2)) * sin(q(3)) + 0.4450000000e0 * m3 * lmy3 * dq(3) * cos(q(2)) * cos(q(3)) - 0.2e1 * dq(1) * I3x * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) + 0.7000000000e-1 * dq(1) * m3 * lmx3 * sin(q(2)) * sin(q(3)) - 0.7000000000e-1 * dq(1) * m3 * lmx3 * cos(q(2)) * cos(q(3)) - 0.7000000000e-1 * dq(1) * m3 * lmz3 * sin(q(2)) * cos(q(3)) - 0.7000000000e-1 * dq(1) * m3 * lmz3 * cos(q(2)) * sin(q(3)) - 0.3960500000e0 * dq(1) * m3 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) + 0.2e1 * dq(1) * I3z * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.1602000000e0 * dq(1) * m3 * cos(q(2)) * sin(q(3)) * sin(q(2)) + 0.4e1 * dq(1) * m3 * lmx3 * cos(q(2)) * cos(q(3)) * lmz3 * sin(q(3)) * sin(q(2)) + 0.2e1 * dq(1) * m3 * lmx3 * cos(q(2)) ^ 2 * lmz3 + 0.1602000000e0 * dq(1) * m3 * cos(q(2)) ^ 2 * cos(q(3)) - 0.3115000000e-1 * dq(1) * m3 * cos(q(2)) * sin(q(3)) - 0.3115000000e-1 * dq(1) * m3 * sin(q(2)) * cos(q(3)) + dq(1) * I3x * cos(q(3)) * sin(q(3)) - 0.1e1 * dq(1) * I3z * cos(q(3)) * sin(q(3)) + 0.1980250000e0 * dq(1) * m3 * cos(q(3)) * sin(q(3)) + 0.8900000000e0 * dq(1) * m3 * lmx3 * cos(q(3)) ^ 2 - 0.3600000000e0 * dq(1) * m3 * lmz3 * cos(q(3)) + 0.3600000000e0 * dq(1) * m3 * lmx3 * sin(q(3)) + dq(1) * m3 * lmz3 ^ 2 * cos(q(2)) * sin(q(2)) + 0.8900000000e0 * dq(1) * m3 * lmz3 * cos(q(2)) * sin(q(2)) - 0.1e1 * dq(1) * m3 * lmx3 * lmz3 + 0.1780000000e1 * dq(1) * m3 * lmx3 * cos(q(2)) * cos(q(3)) * sin(q(3)) * sin(q(2)) - 0.1e1 * dq(1) * m3 * lmx3 ^ 2 * cos(q(2)) * sin(q(2)) - 0.4450000000e0 * dq(1) * m3 * lmx3 + 0.1980250000e0 * dq(1) * m3 * cos(q(2)) * sin(q(2)) + dq(1) * I3x * cos(q(2)) * sin(q(2)) - 0.1e1 * dq(1) * I3z * cos(q(2)) * sin(q(2)) + 0.8900000000e0 * dq(1) * m3 * lmx3 * cos(q(2)) ^ 2; 0.2500000000e-4 * dq(1) * (0.17800e5 * m3 * lmx3 + 0.40000e5 * m2 * lmx2 * lmy2 + 0.14400e5 * m2 * lmy2 - 0.35600e5 * m3 * lmx3 * cos(q(2)) ^ 2 + 0.80000e5 * I3x * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.28800e5 * m2 * cos(q(2)) ^ 2 * lmy2 - 0.2800e4 * m3 * lmx3 * sin(q(2)) * sin(q(3)) + 0.2800e4 * m3 * lmx3 * cos(q(2)) * cos(q(3)) + 0.2800e4 * m3 * lmz3 * sin(q(2)) * cos(q(3)) + 0.2800e4 * m3 * lmz3 * cos(q(2)) * sin(q(3)) - 0.12816e5 * m3 * cos(q(2)) ^ 2 * cos(q(3)) + 0.15842e5 * m3 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) + 0.40000e5 * m2 * lmy2 ^ 2 * cos(q(2)) * sin(q(2)) - 0.40000e5 * m2 * cos(q(2)) * lmx2 ^ 2 * sin(q(2)) - 0.28800e5 * m2 * cos(q(2)) * lmx2 * sin(q(2)) - 0.80000e5 * I3z * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.40000e5 * m3 * lmz3 ^ 2 * cos(q(2)) * sin(q(2)) - 0.35600e5 * m3 * lmz3 * cos(q(2)) * sin(q(2)) + 0.40000e5 * m3 * lmx3 ^ 2 * cos(q(2)) * sin(q(2)) + 0.12816e5 * m3 * cos(q(2)) * sin(q(3)) * sin(q(2)) + 0.80000e5 * m3 * lmz3 ^ 2 * cos(q(2)) ^ 2 * cos(q(3)) * sin(q(3)) + 0.71200e5 * m3 * lmz3 * cos(q(2)) ^ 2 * cos(q(3)) * sin(q(3)) - 0.80000e5 * m3 * lmx3 ^ 2 * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) + 0.160000e6 * m3 * lmx3 * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 * lmz3 - 0.71200e5 * m3 * lmx3 * cos(q(2)) * cos(q(3)) * sin(q(3)) * sin(q(2)) - 0.40000e5 * I3x * cos(q(2)) * sin(q(2)) - 0.2800e4 * m2 * cos(q(2)) * lmx2 + 0.1246e4 * m3 * cos(q(2)) * sin(q(3)) + 0.2800e4 * m2 * sin(q(2)) * lmy2 + 0.1246e4 * m3 * sin(q(2)) * cos(q(3)) - 0.13105e5 * m3 * cos(q(2)) * sin(q(2)) + 0.40000e5 * cos(q(2)) * I2x * sin(q(2)) + 0.40000e5 * I3z * cos(q(2)) * sin(q(2)) - 0.40000e5 * I3x * cos(q(3)) * sin(q(3)) + 0.40000e5 * I3z * cos(q(3)) * sin(q(3)) - 0.7921e4 * m3 * cos(q(3)) * sin(q(3)) - 0.14400e5 * m3 * lmx3 * sin(q(3)) + 0.14400e5 * m3 * lmz3 * cos(q(3)) + 0.15842e5 * m3 * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.80000e5 * m3 * lmx3 * cos(q(2)) ^ 2 * lmz3 + 0.80000e5 * I3x * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.80000e5 * I3z * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.80000e5 * m2 * cos(q(2)) ^ 2 * lmx2 * lmy2 + 0.28800e5 * m3 * cos(q(2)) ^ 2 * lmx3 * sin(q(3)) - 0.28800e5 * m3 * cos(q(2)) ^ 2 * lmz3 * cos(q(3)) - 0.80000e5 * m3 * lmx3 ^ 2 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) + 0.80000e5 * m3 * lmz3 ^ 2 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) + 0.71200e5 * m3 * lmz3 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) + 0.28800e5 * m3 * lmx3 * cos(q(2)) * cos(q(3)) * sin(q(2)) + 0.28800e5 * m3 * lmz3 * cos(q(2)) * sin(q(3)) * sin(q(2)) + 0.71200e5 * m3 * lmx3 * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 - 0.80000e5 * m3 * lmx3 * cos(q(3)) ^ 2 * lmz3 - 0.160000e6 * m3 * lmx3 * cos(q(2)) * cos(q(3)) * lmz3 * sin(q(3)) * sin(q(2)) - 0.1008e4 * m2 * cos(q(2)) - 0.1008e4 * m3 * cos(q(2)) + 0.6408e4 * m3 * cos(q(3)) - 0.40000e5 * m3 * lmz3 ^ 2 * cos(q(3)) * sin(q(3)) - 0.35600e5 * m3 * lmz3 * cos(q(3)) * sin(q(3)) + 0.40000e5 * m3 * lmx3 ^ 2 * cos(q(3)) * sin(q(3)) - 0.35600e5 * m3 * lmx3 * cos(q(3)) ^ 2 - 0.5184e4 * m2 * cos(q(2)) * sin(q(2)) - 0.40000e5 * I2y * cos(q(2)) * sin(q(2)) + 0.40000e5 * m3 * lmx3 * lmz3) -0.1800000000e-2 * dq(3) * m3 * (0.89e2 * cos(q(3)) - 0.200e3 * lmx3 * sin(q(3)) + 0.200e3 * lmz3 * cos(q(3))) -0.1800000000e-2 * m3 * (0.89e2 * dq(2) * cos(q(3)) - 0.200e3 * dq(2) * lmx3 * sin(q(3)) + 0.200e3 * dq(2) * lmz3 * cos(q(3)) + 0.89e2 * dq(3) * cos(q(3)) - 0.200e3 * dq(3) * lmx3 * sin(q(3)) + 0.200e3 * dq(3) * lmz3 * cos(q(3))); 0.2500000000e-4 * dq(1) * (0.17800e5 * m3 * lmx3 - 0.35600e5 * m3 * lmx3 * cos(q(2)) ^ 2 + 0.80000e5 * I3x * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.2800e4 * m3 * lmx3 * sin(q(2)) * sin(q(3)) + 0.2800e4 * m3 * lmx3 * cos(q(2)) * cos(q(3)) + 0.2800e4 * m3 * lmz3 * sin(q(2)) * cos(q(3)) + 0.2800e4 * m3 * lmz3 * cos(q(2)) * sin(q(3)) - 0.6408e4 * m3 * cos(q(2)) ^ 2 * cos(q(3)) + 0.15842e5 * m3 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.80000e5 * I3z * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) - 0.40000e5 * m3 * lmz3 ^ 2 * cos(q(2)) * sin(q(2)) - 0.35600e5 * m3 * lmz3 * cos(q(2)) * sin(q(2)) + 0.40000e5 * m3 * lmx3 ^ 2 * cos(q(2)) * sin(q(2)) + 0.6408e4 * m3 * cos(q(2)) * sin(q(3)) * sin(q(2)) + 0.80000e5 * m3 * lmz3 ^ 2 * cos(q(2)) ^ 2 * cos(q(3)) * sin(q(3)) + 0.71200e5 * m3 * lmz3 * cos(q(2)) ^ 2 * cos(q(3)) * sin(q(3)) - 0.80000e5 * m3 * lmx3 ^ 2 * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) + 0.160000e6 * m3 * lmx3 * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 * lmz3 - 0.71200e5 * m3 * lmx3 * cos(q(2)) * cos(q(3)) * sin(q(3)) * sin(q(2)) - 0.40000e5 * I3x * cos(q(2)) * sin(q(2)) + 0.1246e4 * m3 * cos(q(2)) * sin(q(3)) + 0.1246e4 * m3 * sin(q(2)) * cos(q(3)) - 0.7921e4 * m3 * cos(q(2)) * sin(q(2)) + 0.40000e5 * I3z * cos(q(2)) * sin(q(2)) - 0.40000e5 * I3x * cos(q(3)) * sin(q(3)) + 0.40000e5 * I3z * cos(q(3)) * sin(q(3)) - 0.7921e4 * m3 * cos(q(3)) * sin(q(3)) - 0.14400e5 * m3 * lmx3 * sin(q(3)) + 0.14400e5 * m3 * lmz3 * cos(q(3)) + 0.15842e5 * m3 * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.80000e5 * m3 * lmx3 * cos(q(2)) ^ 2 * lmz3 + 0.80000e5 * I3x * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) - 0.80000e5 * I3z * cos(q(2)) ^ 2 * sin(q(3)) * cos(q(3)) + 0.14400e5 * m3 * cos(q(2)) ^ 2 * lmx3 * sin(q(3)) - 0.14400e5 * m3 * cos(q(2)) ^ 2 * lmz3 * cos(q(3)) - 0.80000e5 * m3 * lmx3 ^ 2 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) + 0.80000e5 * m3 * lmz3 ^ 2 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) + 0.71200e5 * m3 * lmz3 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) + 0.14400e5 * m3 * lmx3 * cos(q(2)) * cos(q(3)) * sin(q(2)) + 0.14400e5 * m3 * lmz3 * cos(q(2)) * sin(q(3)) * sin(q(2)) + 0.71200e5 * m3 * lmx3 * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 - 0.80000e5 * m3 * lmx3 * cos(q(3)) ^ 2 * lmz3 - 0.160000e6 * m3 * lmx3 * cos(q(2)) * cos(q(3)) * lmz3 * sin(q(3)) * sin(q(2)) + 0.6408e4 * m3 * cos(q(3)) - 0.40000e5 * m3 * lmz3 ^ 2 * cos(q(3)) * sin(q(3)) - 0.35600e5 * m3 * lmz3 * cos(q(3)) * sin(q(3)) + 0.40000e5 * m3 * lmx3 ^ 2 * cos(q(3)) * sin(q(3)) - 0.35600e5 * m3 * lmx3 * cos(q(3)) ^ 2 + 0.40000e5 * m3 * lmx3 * lmz3) 0.1800000000e-2 * dq(2) * m3 * (0.89e2 * cos(q(3)) - 0.200e3 * lmx3 * sin(q(3)) + 0.200e3 * lmz3 * cos(q(3))) 0;];

end