%from Stepan Pchelkin

function M = M(q)
%returns the M matrix from the manipulator model

global m1 m2 m3;
global lmx1 lmz1;
global lmx2 lmy2 lmz2;
global lmx3 lmy3 lmz3;
global I1y;
global I2x I2y I2z;
global I3x I3y I3z;


M = [-0.3960500000e0 * m3 * cos(q(2)) * sin(q(3)) * sin(q(2)) * cos(q(3)) + 0.2e1 * m3 * lmx3 * cos(q(3)) * lmz3 * sin(q(3)) + 0.2e1 * m3 * lmx3 * sin(q(2)) * lmz3 * cos(q(2)) + 0.8900000000e0 * m3 * lmx3 * cos(q(2)) * sin(q(2)) + 0.4900000000e-2 * m1 + 0.1345000000e0 * m2 + m3 * lmz3 ^ 2 + 0.8900000000e0 * m3 * lmz3 - 0.2e1 * m3 * lmz3 ^ 2 * cos(q(2)) * cos(q(3)) * sin(q(2)) * sin(q(3)) - 0.1780000000e1 * m3 * lmz3 * cos(q(2)) * cos(q(3)) * sin(q(2)) * sin(q(3)) + 0.2e1 * m3 * lmx3 ^ 2 * cos(q(2)) * sin(q(3)) * sin(q(2)) * cos(q(3)) + m2 * lmx2 ^ 2 + 0.7200000000e0 * m2 * lmx2 + 0.2e1 * I3x * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 - 0.2e1 * I3x * cos(q(2)) * sin(q(3)) * sin(q(2)) * cos(q(3)) + 0.2e1 * I3z * cos(q(2)) * sin(q(3)) * sin(q(2)) * cos(q(3)) + 0.7200000000e0 * m2 * cos(q(2)) * lmy2 * sin(q(2)) + m1 * lmx1 ^ 2 + 0.1400000000e0 * m1 * lmx1 + m1 * lmz1 ^ 2 + m2 * lmz2 ^ 2 + m3 * lmy3 ^ 2 + 0.2e1 * m2 * cos(q(2)) * lmx2 * sin(q(2)) * lmy2 + 0.5040000000e-1 * m2 * sin(q(2)) - 0.1400000000e0 * m3 * lmx3 * cos(q(2)) * sin(q(3)) - 0.1400000000e0 * m3 * lmx3 * sin(q(2)) * cos(q(3)) + 0.1400000000e0 * m3 * lmz3 * cos(q(2)) * cos(q(3)) + 0.5040000000e-1 * m3 * sin(q(2)) + 0.1400000000e0 * m2 * sin(q(2)) * lmx2 + 0.1400000000e0 * m2 * cos(q(2)) * lmy2 - 0.6230000000e-1 * m3 * sin(q(2)) * sin(q(3)) + 0.6230000000e-1 * m3 * cos(q(2)) * cos(q(3)) - 0.1400000000e0 * m3 * lmz3 * sin(q(2)) * sin(q(3)) - 0.7200000000e0 * m3 * cos(q(2)) * lmx3 * sin(q(2)) * sin(q(3)) + 0.7200000000e0 * m3 * cos(q(2)) * lmz3 * sin(q(2)) * cos(q(3)) + 0.3204000000e0 * m3 * cos(q(2)) * sin(q(2)) * cos(q(3)) - 0.1296000000e0 * m2 * cos(q(2)) ^ 2 - 0.1e1 * I2y * cos(q(2)) ^ 2 - 0.1e1 * I3x * cos(q(3)) ^ 2 - 0.1e1 * I3x * cos(q(2)) ^ 2 + I3z * cos(q(2)) ^ 2 + I3z * cos(q(3)) ^ 2 - 0.3276250000e0 * m3 * cos(q(2)) ^ 2 - 0.1980250000e0 * m3 * cos(q(3)) ^ 2 + 0.3960500000e0 * m3 * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 + m2 * lmy2 ^ 2 * cos(q(2)) ^ 2 - 0.1e1 * m2 * cos(q(2)) ^ 2 * lmx2 ^ 2 - 0.7200000000e0 * m2 * cos(q(2)) ^ 2 * lmx2 - 0.2e1 * I3z * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 - 0.1e1 * m3 * lmz3 ^ 2 * cos(q(2)) ^ 2 - 0.1e1 * m3 * lmz3 ^ 2 * cos(q(3)) ^ 2 - 0.8900000000e0 * m3 * lmz3 * cos(q(2)) ^ 2 - 0.8900000000e0 * m3 * lmz3 * cos(q(3)) ^ 2 + m3 * lmx3 ^ 2 * cos(q(3)) ^ 2 + m3 * lmx3 ^ 2 * cos(q(2)) ^ 2 + 0.3204000000e0 * m3 * cos(q(2)) ^ 2 * sin(q(3)) - 0.2e1 * m3 * lmx3 ^ 2 * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 + 0.2e1 * m3 * lmz3 ^ 2 * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 + 0.1780000000e1 * m3 * lmz3 * cos(q(2)) ^ 2 * cos(q(3)) ^ 2 + 0.7200000000e0 * m3 * lmx3 * cos(q(2)) ^ 2 * cos(q(3)) + 0.7200000000e0 * m3 * lmz3 * cos(q(2)) ^ 2 * sin(q(3)) - 0.4e1 * m3 * lmx3 * cos(q(2)) ^ 2 * cos(q(3)) * lmz3 * sin(q(3)) - 0.4e1 * m3 * lmx3 * cos(q(2)) * cos(q(3)) ^ 2 * lmz3 * sin(q(2)) - 0.1780000000e1 * m3 * lmx3 * cos(q(2)) ^ 2 * cos(q(3)) * sin(q(3)) - 0.1780000000e1 * m3 * lmx3 * cos(q(2)) * cos(q(3)) ^ 2 * sin(q(2)) + 0.8900000000e0 * m3 * lmx3 * cos(q(3)) * sin(q(3)) + cos(q(2)) ^ 2 * I2x + I1y + I2y + 0.3325250000e0 * m3 + I3x - 0.7200000000e0 * m3 * lmx3 * cos(q(3)) - 0.7200000000e0 * m3 * lmz3 * sin(q(3)) - 0.3204000000e0 * m3 * sin(q(3)) 0.4450000000e0 * m3 * lmy3 * cos(q(2)) * sin(q(3)) + 0.4450000000e0 * m3 * lmy3 * sin(q(2)) * cos(q(3)) + m3 * lmy3 * lmx3 * cos(q(2)) * cos(q(3)) - 0.1e1 * m3 * lmy3 * lmx3 * sin(q(2)) * sin(q(3)) + m3 * lmy3 * lmz3 * cos(q(2)) * sin(q(3)) + m3 * lmy3 * lmz3 * sin(q(2)) * cos(q(3)) - 0.3600000000e0 * m2 * lmz2 * cos(q(2)) + m2 * lmz2 * sin(q(2)) * lmy2 - 0.1e1 * m2 * lmz2 * cos(q(2)) * lmx2 - 0.3600000000e0 * m3 * lmy3 * cos(q(2)) 0.5000000000e-2 * m3 * lmy3 * (0.200e3 * lmx3 * cos(q(2)) * cos(q(3)) - 0.200e3 * lmx3 * sin(q(2)) * sin(q(3)) + 0.200e3 * lmz3 * cos(q(2)) * sin(q(3)) + 0.200e3 * lmz3 * sin(q(2)) * cos(q(3)) + 0.89e2 * cos(q(2)) * sin(q(3)) + 0.89e2 * sin(q(2)) * cos(q(3))); 0.4450000000e0 * m3 * lmy3 * cos(q(2)) * sin(q(3)) + 0.4450000000e0 * m3 * lmy3 * sin(q(2)) * cos(q(3)) + m3 * lmy3 * lmx3 * cos(q(2)) * cos(q(3)) - 0.1e1 * m3 * lmy3 * lmx3 * sin(q(2)) * sin(q(3)) + m3 * lmy3 * lmz3 * cos(q(2)) * sin(q(3)) + m3 * lmy3 * lmz3 * sin(q(2)) * cos(q(3)) - 0.3600000000e0 * m2 * lmz2 * cos(q(2)) + m2 * lmz2 * sin(q(2)) * lmy2 - 0.1e1 * m2 * lmz2 * cos(q(2)) * lmx2 - 0.3600000000e0 * m3 * lmy3 * cos(q(2)) m3 * lmx3 ^ 2 + 0.1296000000e0 * m2 + m3 * lmz3 ^ 2 + 0.8900000000e0 * m3 * lmz3 + m2 * lmy2 ^ 2 + m2 * lmx2 ^ 2 + 0.7200000000e0 * m2 * lmx2 + I2z + 0.3276250000e0 * m3 + I3y - 0.3204000000e0 * m3 * sin(q(3)) - 0.7200000000e0 * m3 * lmx3 * cos(q(3)) - 0.7200000000e0 * m3 * lmz3 * sin(q(3)) m3 * lmx3 ^ 2 + m3 * lmz3 ^ 2 + 0.8900000000e0 * m3 * lmz3 + 0.1980250000e0 * m3 + I3y - 0.1602000000e0 * m3 * sin(q(3)) - 0.3600000000e0 * m3 * lmx3 * cos(q(3)) - 0.3600000000e0 * m3 * lmz3 * sin(q(3)); 0.5000000000e-2 * m3 * lmy3 * (0.200e3 * lmx3 * cos(q(2)) * cos(q(3)) - 0.200e3 * lmx3 * sin(q(2)) * sin(q(3)) + 0.200e3 * lmz3 * cos(q(2)) * sin(q(3)) + 0.200e3 * lmz3 * sin(q(2)) * cos(q(3)) + 0.89e2 * cos(q(2)) * sin(q(3)) + 0.89e2 * sin(q(2)) * cos(q(3))) m3 * lmx3 ^ 2 + m3 * lmz3 ^ 2 + 0.8900000000e0 * m3 * lmz3 + 0.1980250000e0 * m3 + I3y - 0.1602000000e0 * m3 * sin(q(3)) - 0.3600000000e0 * m3 * lmx3 * cos(q(3)) - 0.3600000000e0 * m3 * lmz3 * sin(q(3)) m3 * lmx3 ^ 2 + m3 * lmz3 ^ 2 + 0.8900000000e0 * m3 * lmz3 + 0.1980250000e0 * m3 + I3y;];

end